<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/tools.php";
include_once "include/mime.php";
include_once "$theme/theme.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

$operator        = $_REQUEST['operator'];
$rule_identifier = $_REQUEST['rule'];
$select_folder   = $_REQUEST['select_folder'];

if (!$select_folder) {
  /* return if no search criteria exists */
  header("location: my.tools.php?selector=1&rule=$rule_identifier");
}

include_once "include/common.php";
include_once "include/site.php";
include_once "include/import.php";
include_once "include/database.php";

$database = po_dbconnect();
$my_user_id = pg_fetch_row(pg_query($database, "select identifier, type from users where session_id='$session_id'"));
if ($my_user_id[1] < $user_type['user']) {
  pg_close($database);
  header("location: login.php");
  exit();
}

$set_rule_name              = $_REQUEST['set_rule_name'];
$set_generate_thumbnail     = $_REQUEST['set_generate_thumbnail'];
$set_generate_preview       = $_REQUEST['set_generate_preview'];

$set_title                  = $_REQUEST['set_title'];
$set_author                 = $_REQUEST['set_author'];
$set_keyword                = $_REQUEST['set_keyword'];
$set_headline               = $_REQUEST['set_headline'];
$set_caption_writer         = $_REQUEST['set_caption_writer'];
$set_caption                = $_REQUEST['set_caption'];
$set_category               = $_REQUEST['set_category'];
$set_supplemental_category  = $_REQUEST['set_supplemental_category'];
$set_credit                 = $_REQUEST['set_credit'];
$set_copyright              = $_REQUEST['set_copyright'];
$set_web_statement          = $_REQUEST['set_web_statement'];
$set_instructions           = $_REQUEST['set_instructions'];
$set_source                 = $_REQUEST['set_source'];
$set_transmission_reference = $_REQUEST['set_transmission_reference'];

$set_date_of_exposure       = check_date_validity($_REQUEST['set_date_of_exposure']);
$set_location               = $_REQUEST['set_location'];
$set_access_rights          = $_REQUEST['set_access_rights'];
$set_hide_original          = $_REQUEST['set_hide_original'];
$set_camera                 = $_REQUEST['set_camera'];
$set_camera_metering        = $_REQUEST['set_camera_metering'];
$set_camera_program         = $_REQUEST['set_camera_program'];
$set_lens                   = $_REQUEST['set_lens'];
$set_focal_length           = $_REQUEST['set_focal_length'];
$set_filter                 = $_REQUEST['set_filter'];
$set_film                   = $_REQUEST['set_film'];
$set_iso_override           = $_REQUEST['set_iso_override'];
$set_aperture               = $_REQUEST['set_aperture'];
$set_shutter                = $_REQUEST['set_shutter'];
$set_exp_comp               = $_REQUEST['set_exp_comp'];
$set_exp_diff               = $_REQUEST['set_exp_diff'];
$set_flash                  = $_REQUEST['set_flash'];
$set_flash_mode             = $_REQUEST['set_flash_mode'];
$set_flash_comp             = $_REQUEST['set_flash_comp'];
$set_scanner                = $_REQUEST['set_scanner'];
$set_scan_resolution        = $_REQUEST['set_scan_resolution'];
$set_scan_bitdepth          = $_REQUEST['set_scan_bitdepth'];
$set_scan_multiscan         = $_REQUEST['set_scan_multiscan'];
$set_support                = $_REQUEST['set_support'];

if ($rule_identifier) {
  if ($operator == "save") {
    /* update exisiting new rule */
    $result = pg_query($database, "
     update bulk_update_rule set
       rule_name              = '$set_rule_name',
       regenerate_thumbnail   = '$set_generate_thumbnail',
       regenerate_preview     = '$set_generate_preview',
       title                  = '$set_title',
       author                 = '$set_author',
       keyword                = '$set_keyword',
       headline               = '$set_headline',
       caption_writer         = '$set_caption_writer',
       caption                = '$set_caption',
       category               = '$set_category',
       supplemental_category  = '$set_supplemental_category',
       credit                 = '$set_credit',
       copyright_statement    = '$set_copyright',
       web_statement          = '$set_web_statement',
       instructions           = '$set_instructions',
       source                 = '$set_source',
       transmission_reference = '$set_transmission_reference',
       date_of_exposure       = $set_date_of_exposure,
       access_rights          = $set_access_rights,
       hide_original          = '$set_hide_original',
       location               = $set_location,
       camera                 = $set_camera,
       camera_metering        = $set_camera_metering,
       camera_program         = $set_camera_program,
       lens                   = $set_lens,
       focal_length           = $set_focal_length,
       filter                 = $set_filter,
       film                   = $set_film,
       iso_override           = $set_iso_override,
       aperture               = $set_aperture,
       shutter                = $set_shutter,
       exposure_comp          = $set_exp_comp,
       ev_difference          = $set_exp_diff,
       flash                  = $set_flash,
       flash_mode             = $set_flash_mode,
       flash_comp             = $set_flash_comp,
       scanner                = $set_scanner,
       scan_resolution        = $set_scan_resolution,
       scan_bitdepth          = $set_scan_bitdepth,
       scan_multiscan         = $set_scan_multiscan,
       support                = $set_support
     where identifier = $rule_identifier");
  }
  else if ($operator == "delete") {
    $result = pg_query($database, " delete from bulk_update_rule where identifier = $rule_identifier");
  }
}
else {
  /* create a new rule */
  if ($operator == "save") {
    $new_rule_identifier = pg_fetch_row(pg_query($database, "select nextval('bulk_update_rule_id_sequence')"));
    $rule_identifier = $new_rule_identifier[0];
    $result = pg_query($database, "
     insert into bulk_update_rule (identifier, users, rule_name, regenerate_thumbnail, regenerate_preview, title, author, keyword, headline,
       caption_writer, caption, category, supplemental_category, credit, copyright_statement,
       web_statement, instructions, source, transmission_reference, date_of_exposure, access_rights,
       hide_original, location, camera, camera_metering, camera_program, lens, focal_length,
       filter, film, iso_override, aperture, shutter, exposure_comp, ev_difference, flash,
       flash_mode, flash_comp, scanner, scan_resolution, scan_bitdepth, scan_multiscan, support)
     values ($rule_identifier, $my_user_id[0], '$set_rule_name', '$set_generate_thumbnail', '$set_generate_preview', '$set_title', '$set_author', '$set_keyword', '$set_headline',
       '$set_caption_writer', '$set_caption', '$set_category', '$set_supplemental_category', '$set_credit', '$set_copyright',
       '$set_web_statement', '$set_instructions', '$set_source', '$set_transmission_reference', $set_date_of_exposure, $set_access_rights,
       '$set_hide_original', $set_location, $set_camera, $set_camera_metering, $set_camera_program, $set_lens, $set_focal_length,
       $set_filter, $set_film, $set_iso_override, $set_aperture, $set_shutter, $set_exp_comp, $set_exp_diff, $set_flash,
       $set_flash_mode, $set_flash_comp, $set_scanner, $set_scan_resolution, $set_scan_bitdepth, $set_scan_multiscan, $set_support)");
  }
}

if ($operator != "submit") {
  /* return if a rule operation was performed */
  pg_close($database);
  header("location: my.tools.php?selector=1&rule=$rule_identifier");
}

site_header($page_width, "Photo Organizer : Display Tools");
site_navigator(10, $my_user_id[1]);
site_navigator_staus("<a href=\"user.php\">Users</a> : My Tools", "");

print "&nbsp;<br>";
display_navigator_box_top($tools_data['bulkupdate']['idx'], $tools_data, "100%");

$update_photo = false;
$update_photo_tech = false;

if ($set_title                     ) { $update_photo = true; $sql_title                  = " title = '$set_title', "; }
if ($set_author                    ) { $update_photo = true; $sql_author                 = " author = '$set_author', "; }
if ($set_keyword                   ) { $update_photo = true; $sql_keyword                = " keyword = '$set_keyword', "; }
if ($set_headline                  ) { $update_photo = true; $sql_headline               = " headline = '$set_headline', "; }
if ($set_caption_writer            ) { $update_photo = true; $sql_caption_writer         = " caption_writer = '$set_caption_writer', "; }
if ($set_caption                   ) { $update_photo = true; $sql_caption                = " caption = '$set_caption', "; }
if ($set_category                  ) { $update_photo = true; $sql_category               = " category = '$set_category', "; }
if ($set_supplemental_category     ) { $update_photo = true; $sql_supplemental_category  = " supplemental_category = '$set_supplemental_category', "; }
if ($set_credit                    ) { $update_photo = true; $sql_credit                 = " credit = '$set_credit', "; }
if ($set_copyright                 ) { $update_photo = true; $sql_copyright              = " copyright_statement = '$set_copyright', "; }
if ($set_web_statement             ) { $update_photo = true; $sql_web_statement          = " web_statement = '$set_web_statement', "; }
if ($set_instructions              ) { $update_photo = true; $sql_instructions           = " instructions = '$set_instructions', "; }
if ($set_source                    ) { $update_photo = true; $sql_source                 = " source = '$set_source', "; }
if ($set_transmission_reference    ) { $update_photo = true; $sql_transmission_reference = " transmission_reference = '$set_transmission_reference', "; }
if ($set_date_of_exposure != "null") { $update_photo = true; $sql_date_of_exposure       = " date_of_exposure = $set_date_of_exposure, "; }
if ($set_location != "null"        ) { $update_photo = true; $sql_location               = " location = $set_location, "; }
if ($set_access_rights != "null"   ) { $update_photo = true; $sql_access_rights          = " access_rights = $set_access_rights, "; }
if ($set_hide_original != "null"   ) { $update_photo = true; $sql_hide_original          = " hide_original = '$set_hide_original', "; }


if ($set_camera != "null"          ) { $update_photo_tech = true; $sql_camera           = " camera = $set_camera, "; }
if ($set_camera_metering != "null" ) { $update_photo_tech = true; $sql_camera_metering  = " camera_metering = $set_camera_metering, "; }
if ($set_camera_program != "null"  ) { $update_photo_tech = true; $sql_camera_program   = " camera_program = $set_camera_program, "; }
if ($set_lens != "null"            ) { $update_photo_tech = true; $sql_lens             = " lens = $set_lens, "; }
if ($set_focal_length != "null"    ) { $update_photo_tech = true; $sql_focal_length     = " focal_length = $set_focal_length, "; }
if ($set_filter != "null"          ) { $update_photo_tech = true; $sql_filter           = " filter = $set_filter, "; }
if ($set_film != "null"            ) { $update_photo_tech = true; $sql_film             = " film = $set_film, "; }
if ($set_iso_override != "null"    ) { $update_photo_tech = true; $sql_iso_override     = " iso_override = $set_iso_override, "; }
if ($set_aperture != "null"        ) { $update_photo_tech = true; $sql_aperture         = " aperture = $set_aperture, "; }
if ($set_shutter != "null"         ) { $update_photo_tech = true; $sql_shutter          = " shutter = $set_shutter, "; }
if ($set_exp_comp != "null"        ) { $update_photo_tech = true; $sql_exp_comp         = " exposure_comp = $set_exp_comp, "; }
if ($set_exp_diff != "null"        ) { $update_photo_tech = true; $sql_exp_diff         = " ev_difference = $set_exp_diff, "; }
if ($set_flash != "null"           ) { $update_photo_tech = true; $sql_flash            = " flash = $set_flash, "; }
if ($set_flash_mode != "null"      ) { $update_photo_tech = true; $sql_flash_mode       = " flash_mode = $set_flash_mode, "; }
if ($set_flash_comp != "null"      ) { $update_photo_tech = true; $sql_flash_comp       = " flash_comp = $set_flash_comp, "; }
if ($set_scanner != "null"         ) { $update_photo_tech = true; $sql_scanner          = " scanner = $set_scanner, "; }
if ($set_scan_resolution != "null" ) { $update_photo_tech = true; $sql_scan_resolution  = " scan_resolution = $set_scan_resolution, "; }
if ($set_scan_bitdepth != "null"   ) { $update_photo_tech = true; $sql_scan_bitdepth    = " scan_bitdepth = $set_scan_bitdepth, "; }
if ($set_scan_multiscan != "null"  ) { $update_photo_tech = true; $sql_scan_multiscan   = " scan_multiscan = $set_scan_multiscan, "; }
if ($set_support != "null"         ) { $update_photo_tech = true; $sql_support          = " support = $set_support, "; }

if ($select_folder == "all") {
  $sql_selector = " users = $my_user_id[0] ";
}
else {
  $sql_selector = " folder = $select_folder ";
}

$num_of_updates = pg_fetch_row(pg_query($database, "
  select count(identifier) from photo
   where $sql_selector"));

if ($update_photo) {
  /* append all strings */
  $sql_appended = $sql_title.$sql_author.$sql_keyword.$sql_headline.$sql_caption_writer.$sql_caption.$sql_category.$sql_supplemental_category.$sql_credit.$sql_copyright.$sql_web_statement.$sql_instructions.$sql_source.$sql_transmission_reference.$sql_date_of_exposure.$sql_location.$sql_access_rights.$sql_hide_original;
  /* remove last coma */
  $sql_appended = substr($sql_appended, 0, strlen($sql_appended) - 2);

/*   print "$sql_appended"; */

  $result = pg_query($database, "
  update photo set
     $sql_appended
   where $sql_selector");
}

if ($update_photo_tech) {
  /* append all strings */
  $sql_appended = $sql_camera.$sql_camera_metering.$sql_camera_program.$sql_lens.$sql_focal_length.$sql_filter.$sql_film.$sql_iso_override.$sql_aperture.$sql_shutter.$sql_exp_comp.$sql_exp_diff.$sql_flash.$sql_flash_mode.$sql_flash_comp.$sql_scanner.$sql_scan_resolution.$sql_scan_bitdepth.$sql_scan_multiscan.$sql_support;
  /* remove last coma */
  $sql_appended = substr($sql_appended, 0, strlen($sql_appended) - 2);

/*   print "$sql_appended"; */

  $result = pg_query($database, "
  update photo_tech set
     $sql_appended
   where photo in (select identifier from photo where $sql_selector)");
}

print "<p align=\"left\">Updated $num_of_updates[0] photos.</p>";

if (($set_generate_thumbnail == 't') || ($set_generate_preview == 't')) {
  $im_options = get_im_options($database, $my_user_id[0]);
  $my_im_composite_options = get_im_composite_options($database, $my_user_id[0]);
  $dcraw_options = get_dcraw_options($database, $my_user_id[0]);

  print "<div align=\"left\">";

  $limit = 20;
  $offset = 0;
  while (1) {
    $photo = pg_query($database, "
      select small_image_path, medium_image_path, large_image_path, title, photo.identifier, colorspace, orientation
        from photo, photo_version
       where photo.identifier = photo_version.photo
         and $sql_selector
       limit $limit
      offset $offset");

    $num_of_photos = pg_num_rows($photo);

    if ($num_of_photos == 0)
      break;

    for ($counter = 0; $counter < $num_of_photos; $counter++) {
      $photo_data = pg_fetch_row($photo, $counter);

      $thumb_name    = $image_repository_path ."/". $photo_data[0];
      $image_name    = $image_repository_path ."/". $photo_data[1];
      $original_name = $image_repository_path ."/". $photo_data[2];
      $orientation = orientation_to_xform($database, $photo_data[6]);

      $original_file_type   = strtolower(substr($original_name, strrpos($original_name, ".") + 1));
      $multi_page_parameter = $mime_type[$original_file_type]['page'];
      $decoder              = $mime_type[$original_file_type]['decoder'];
      $postprocessor        = $mime_type[$original_file_type]['postprocessor'];

      print "Regenerating thumbnail and preview for <a href=\"photo.php?photo=$photo_data[4]\">$photo_data[3]</a>.<ul>";

      $temporary_ppm_file = import_raw_decode($original_name, $dcraw_options, $decoder, $postprocessor);
      if ($temporary_ppm_file) {
        $original_name = $temporary_ppm_file;
      }

      if ($set_generate_preview == 't') {
        import_generate_preview($original_name, $image_name, TRUE, $im_options, $my_im_composite_options, $multi_page_parameter, $orientation, $photo_data[5]);
      }

      if ($set_generate_thumbnail == 't') {
        import_generate_thumbnail($original_name, $thumb_name, TRUE, $im_options, $multi_page_parameter, $orientation, $photo_data[5]);
      }
      print "</ul>";
    }

    $offset += $limit;
  }
  print "</div>";
}

print "<p>";
print "<a class=\"nodecor\" href=\"my.tools.php?selector=1&rule=$rule_identifier\"><img src=\"$theme/button.back.gif\" border=\"0\"></a>";
print "</p>";


display_navigator_box_bottom("100%");
print "&nbsp;<br>";

site_footer($database);
pg_close($database);

?>
