<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/mime.php";
include_once "include/calendar.php";
include_once "include/database.php";
include_once "$theme/theme.php";

$session_id   = $_COOKIE[$po_cookie];
$photo_id     = $_REQUEST['image'];
$image_size   = $_REQUEST['size'];
$version      = $_REQUEST['ver'];

if (!$photo_id) {
  exit();
}

$database = po_dbconnect();
$version_selector = $version ? "photo_version.identifier=$version" : "photo_version.master='t'";

$photo_data = pg_fetch_row(pg_query($database, "
  select users, folder,
         small_image_path, medium_image_path, large_image_path,
         access_rights, hide_original, original_image_name
    from photo left join photo_version on photo.identifier = photo_version.photo
   where $version_selector
     and photo.identifier = '$photo_id'"));
if (!$photo_data) {
  pg_close($database);
  exit();
}

$my_user_id = pg_fetch_row(pg_query($database, "
    select identifier, type
      from users
     where session_id='$session_id'"));

$owner_user_id = $photo_data[0];
if ($owner_user_id != "" && $my_user_id[0] != "") {
  $client = pg_fetch_row(pg_query($database, "
    select identifier
      from client
     where users='$owner_user_id'
       and client='$my_user_id[0]'
       and status=$client_status[accepted]"));
}

if ($image_size == 3) {
  if (!$my_user_id[0])
       $my_user_id[0] = "null";
  $all_photo_items_for_sale = pg_query($database, "
    select (select max(download_counter) from shop_order where item=photo_item.identifier and shop_order.client = $my_user_id[0] and transaction is not null) as counter,
           (select max(download_expiry_date) from shop_order where item=photo_item.identifier and shop_order.client = $my_user_id[0] and transaction is not null) as expiry_date,
           (select max(shop_order.identifier) from shop_order, shop_transaction, client where shop_order.transaction=shop_transaction.identifier and shop_order.client = client.client and (client.trusted = 't' or shop_transaction.status = '2')) as purchase_confirmed
      from photo_item, shop_item
     where photo_item.shop_item = shop_item.identifier
       and photo=$photo_id");
}

/* check if the original is hidden or bought */
if ($image_size == 3) {
  $number_of_photos_for_sale = pg_num_rows($all_photo_items_for_sale);
  $photo_on_client_order = false;
  for ($i=0; $i < $number_of_photos_for_sale; $i++) {
    $photo_for_sale = pg_fetch_row($all_photo_items_for_sale, $i);

    if (!$photo_for_sale[2])
      continue;

    if (($photo_for_sale[0] > 0) && (compare_timestamps(date("Y-m-d H:i:s"), $photo_for_sale[1]) > 0)) {
      $photo_on_client_order = true;

      pg_query($database, "update shop_order set download_counter=download_counter-1 where identifier=$photo_for_sale[2]");
      break;
    }
  }

  if (!$photo_on_client_order &&
      ($photo_data[6] == "t") &&
      ($my_user_id[0] != $owner_user_id) &&
      ($my_user_id[1] != $user_type['administrator'])) {
    pg_close($database);
    exit();
  }
}

pg_close($database);

/* if the photo is private and isn't mine return */
if (($photo_data[5] == $access['private']) &&
    ($my_user_id[0] != $owner_user_id) &&
    ($my_user_id[1] != $user_type['administrator'])) {
  exit();
}

/* if the photo is protected and I am not a customer or this user, and the photo isn't mine than  return  */
if (($photo_data[5] == $access['protected']) &&
    ($my_user_id[0] != $owner_user_id) &&
    ($my_user_id[1] != $user_type['administrator']) &&
    ($client == "")) {
  exit();
}

switch ($image_size) {
 default:
 case 1:
   $image_path = $photo_data[2];
   $disposition = "inline";
   break;
 case 2:
   $image_path = $photo_data[3];
   $disposition = "inline";
   break;
 case 3:
   $image_path = $photo_data[4];
   $disposition = "attachment; ";
}

$image_type = substr(strtolower(strrchr ($image_path, ".")), 1);
$mime = $mime_type[$image_type]['type'];

switch ($image_size) {
 case 1:
   $default_path = "themes/null.photo.small.gif";
   $original_image_name = "file.thumbnail.$photo_id.$image_type";
   break;
 default:
 case 2:
   $default_path = "themes/null.photo.large.gif";
   $original_image_name = "file.preview.$photo_id.$image_type";
   break;
 case 3:
   $default_path = "themes/null.photo.large.gif";
   if ($photo_data[7]) {
     $original_image_name = $photo_data[7];
     $image_type = substr(strtolower(strrchr ($original_image_name, ".")), 1);
   }
   else
     $original_image_name = "file.$photo_id.$image_type";
}

$file_name = $default_path;
if (is_file($image_repository_path . "/" . $image_path)) {
  $file_name = $image_repository_path . "/" . $image_path;
}

/* Cache control by THOMAS WENRICH wet@chello.at*/

/* We are about to deliver the image. */
/* It's time to handle the browser caching: */
/* - Images expire after few seconds. */
/* - We handle the If-Modified-Since header for compliant browsers. */

$time_of_last_modification = time();
if ($stat = stat($file_name))
  $time_of_last_modification = $stat[9];

$if_modified_time = -1;
$all_headers = getallheaders();
if ($all_headers && array_key_exists("If-Modified-Since", $all_headers)) {
  // Split the If-Modified-Since (Netscape < v6 gets this wrong)
  $if_modified_since = explode(';', $all_headers['If-Modified-Since']);
  $if_modified_time = strtotime($if_modified_since[0]);
}

if (($if_modified_time != -1) && ($time_of_last_modification <= $if_modified_time)) {
  header("HTTP/1.1 304 Not modified");
  exit(0);
}

$mod_gmt = gmdate("D, d M Y H:i:s", $time_of_last_modification) ." GMT";

/* with exception of Content-Disposition, this should be the same headers */
/* like the headers of a file from the file system */

header("Content-type: $mime/$image_type");
header("Content-Disposition: $disposition; filename=$original_image_name;  modification-date=\"$mod_gmt\";");
header("Last-Modified: $mod_gmt");

$browser = $_SERVER['HTTP_USER_AGENT'];
if (strpos($browser, "MSIE 5")) {
  header("Cache-Control: pre-check=" . $expire);
}

$file_descriptor = fopen($file_name, 'rb');
if ($file_descriptor === false) {
  exit(0);
}

/* read 1M chunks */
while (!feof($file_descriptor)) {
  echo fread($file_descriptor, 1*(1024*1024));
}

fclose($file_descriptor);
exit(0);
?>
