<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "config.php";
include_once "vars.php";

function send_login_information($database, $email) {
  global $user_type;
  global $site_url;

  $failures = 0;

  $valid_emails = pg_query($database, "
     select users.first_name, users.last_name, email, users.username, users.password
       from users, contact_info
      where users.contact = contact_info.identifier
        and contact_info.email = '$email'");

  $num_of_valid_emails = pg_num_rows($valid_emails);
  if ($num_of_valid_emails == 0)
    return FALSE;

  $admin_data = pg_fetch_row(pg_query($database, "
     select users.first_name, users.last_name, email
       from users, contact_info
      where users.contact = contact_info.identifier
        and users.type = $user_type[administrator]"));

  for ($i = 0; $i < $num_of_valid_emails; $i++) {
    $user_data = pg_fetch_row($valid_emails, $i);
    $subject = "Login information request.";
    $message = "
      <html>
        <head>
          <title>Photo Organizer login information</title>
        </head>
        <body text=\"#555555\" bgcolor=\"#FFFFFF\" link=\"#0044AA\" vlink=\"#0044AA\" alink=\"#0044AA\">
          <font size=\"+1\">Dear $user_data[0],</font>
          <p>
          Find below your <a href=\"\">$site_url</a> access codes:
          <p>
          Username: $user_data[3]<br>
          Password: $user_data[4]
          <p>
          This e-mail has been automatically generated by PO. Please do not reply.
          <p>
          $admin_data[0] $admin_data[1], your PO administrator.
        </body>
      </html>";
    $headers  = "MIME-Version: 1.0\r\n";
    $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
    $headers .= "From: $admin_data[2]\r\n";

    if (!mail($user_data[2], $subject, $message, $headers))
      $failures++;
  }
  if ($failures == 0)
    return TRUE;

  return FALSE;
}

function send_new_client_notification($database, $user_id, $client_id) {
  global $user_type;
  global $client_status;
  global $site_url;

  $user_data = pg_query($database, "
     select users.first_name, users.last_name, email
       from users, contact_info
      where users.contact = contact_info.identifier
        and users.identifier = '$user_id'");

  $num_of_to_users = pg_num_rows($user_data);
  if ($num_of_to_users != 1)
    return FALSE;

  $client_data = pg_query($database, "
     select users.first_name, users.last_name, email,
            client_status.value as status, client_status.identifier as statusid, client.date_of_creation as date_of_subscirption
       from users, contact_info, client, client_status
      where users.contact = contact_info.identifier
        and client.status = client_status.identifier
        and client.client = '$client_id'
        and client.users = '$user_id'
        and users.identifier = client.client");

  $num_of_from_users = pg_num_rows($client_data);
  if ($num_of_from_users != 1)
    return FALSE;

  $client_data = pg_fetch_row($client_data);
  $user_data   = pg_fetch_row($user_data);

  $admin_data = pg_fetch_row(pg_query($database, "
     select users.first_name, users.last_name, email
       from users, contact_info
      where users.contact = contact_info.identifier
        and users.type = $user_type[administrator]"));

  /* SEND MAIL TO THE USER */

  $client_data[5] = substr($client_data[5], 0, 10);
  $subject = "Photo Organizer Client Subscription Notificaiton";
  $message = "
      <html>
        <head>
          <title>Photo Organizer Client Subscription Notificaiton</title>
        </head>
        <body text=\"#555555\" bgcolor=\"#FFFFFF\" link=\"#0044AA\" vlink=\"#0044AA\" alink=\"#0044AA\">
          <font size=\"+1\">Dear $user_data[0],</font>
          <p>
          On $client_data[5], $client_data[0] $client_data[1] subscribed to
          be one of your clients. His status is: \"$client_data[3]\" which means that $client_data[0] $client_data[1] ";
  if ($client_data[4] == $client_status[pending])
    $message = $message . "cannot access your protected photos.<p>To enable your new client to access
          protected areas of your PO account, please visit your PO workspace and change
          the client status to \"Accepted\"";
  if ($client_data[4] == $client_status[accepted])
    $message = $message . "can access your protected photos.<p>To disable your new client accessing
          protected areas of your PO account, please visit your PO workspace and change
          your new client status' to \"Pending\" or \"Disabled\"";
    $message = $message . "<p>
          This e-mail has been automatically generated by PO. Please do not reply.
          <p>
          $admin_data[0] $admin_data[1], your PO administrator.
          <p>
        </body>
      </html>";
  $headers  = "MIME-Version: 1.0\r\n";
  $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
  $headers .= "From: $client_data[2]\r\n";

  if (!mail($user_data[2], $subject, $message, $headers))
    return FALSE;

  /* SEND MAIL TO THE CLIENT */
  $subject = "Photo Organizer Client Subscription Notificaiton";
  $message = "
      <html>
        <head>
          <title>Photo Organizer Client Subscription Notificaiton</title>
        </head>
        <body text=\"#555555\" bgcolor=\"#FFFFFF\" link=\"#0044AA\" vlink=\"#0044AA\" alink=\"#0044AA\">
          <font size=\"+1\">Dear $client_data[0],</font>
          <p>
          On $client_data[5], you subscribed to
          be one of $user_data[0] $user_data[1] clients. Your status is: \"$client_data[3]\" which means that you ";
  if ($client_data[4] == $client_status[pending])
    $message = $message . "cannot access yet the protected photos of $user_data[0] $user_data[1].<p>
          Short time ago $user_data[0] $user_data[1] also received a notification and he/she will
          evaluate and possibly accept your subscription.";
  if ($client_data[4] == $client_status[accepted])
    $message = $message . "can access the protected photos of $user_data[0] $user_data[1].";
    $message = $message . " Should this happen, you will be notified about the new status of your subscription.
          <p>$user_data[0] $user_data[1] has the rights to change your client
          subscription status at any time, to restrict or grant access to his/her protected
          data.<p>
          This e-mail has been automatically generated by PO.
          <p>
          $admin_data[0] $admin_data[1], your PO administrator.
          <p>
        </body>
      </html>";
  $headers  = "MIME-Version: 1.0\r\n";
  $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
  $headers .= "From: $user_data[2]\r\n";

  if (!mail($client_data[2], $subject, $message, $headers))
    return FALSE;

  return TRUE;
}



function send_client_account_change_notification($database, $user_id, $client_id) {
  global $user_type;
  global $client_status;

  $user_data = pg_query($database, "
     select users.first_name, users.last_name, email
       from users, contact_info
      where users.contact = contact_info.identifier
        and users.identifier = '$user_id'");

  $num_of_to_users = pg_num_rows($user_data);
  if ($num_of_to_users != 1)
    return FALSE;

  $client_data = pg_query($database, "
     select users.first_name, users.last_name, email,
            client_status.value as status, client_status.identifier as statusid, client.date_of_creation as date_of_subscirption
       from users, contact_info, client, client_status
      where users.contact = contact_info.identifier
        and client.status = client_status.identifier
        and client.client = '$client_id'
        and client.users = '$user_id'
        and users.identifier = client.client");

  $num_of_from_users = pg_num_rows($client_data);
  if ($num_of_from_users != 1)
    return FALSE;

  $client_data = pg_fetch_row($client_data);
  $user_data   = pg_fetch_row($user_data);

  $admin_data = pg_fetch_row(pg_query($database, "
     select users.first_name, users.last_name, email
       from users, contact_info
      where users.contact = contact_info.identifier
        and users.type = $user_type[administrator]"));

  /* SEND MAIL TO THE CLIENT */
  $subject = "Photo Organizer Client Account Status Notificaiton";
  $message = "
      <html>
        <head>
          <title>Photo Organizer Client Account Status Notificaiton</title>
        </head>
        <body text=\"#555555\" bgcolor=\"#FFFFFF\" link=\"#0044AA\" vlink=\"#0044AA\" alink=\"#0044AA\">
          <font size=\"+1\">Dear $client_data[0],</font>
          <p>
          $user_data[0] $user_data[1] changed your client subscription status, which currently is: \"$client_data[3]\". This means that you ";
  if ($client_data[4] == $client_status[pending])
    $message = $message . "cannot access the protected photos of $user_data[0] $user_data[1].";
  if ($client_data[4] == $client_status[rejectetd])
    $message = $message . "cannot access the protected photos of $user_data[0] $user_data[1].";
  if ($client_data[4] == $client_status[accepted])
    $message = $message . "can access the protected photos of $user_data[0] $user_data[1].";
    $message = $message . "<p>$user_data[0] $user_data[1] has the rights to change your client
          subscription status at any time, to restrict or grant access to his/her protected
          data. Should this happen, you will be notified about the new status of your
          subscription.<p>
          This e-mail has been automatically generated by PO.
          <p>
          $admin_data[0] $admin_data[1], your PO administrator.
          <p>
        </body>
      </html>";
  $headers  = "MIME-Version: 1.0\r\n";
  $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
  $headers .= "From: $user_data[2]\r\n";

  if (!mail($client_data[2], $subject, $message, $headers))
    return FALSE;

  return TRUE;
}

function send_po_account_change_notification($database, $user_id) {
  global $user_type;

  $user_data = pg_query($database, "
     select users.first_name, users.last_name, email, user_type.identifier, value, bulk_upload_enable, shop_enable,
            quota_size, quota_count
       from users, contact_info, user_type, preferences
      where users.contact = contact_info.identifier
        and users.type = user_type.identifier
        and users.preferences = preferences.identifier
        and users.identifier = '$user_id'");

  $num_of_to_users = pg_num_rows($user_data);
  if ($num_of_to_users != 1)
    return FALSE;

  $user_data   = pg_fetch_row($user_data);
  $admin_data = pg_fetch_row(pg_query($database, "
     select users.first_name, users.last_name, email
       from users, contact_info
      where users.contact = contact_info.identifier
        and users.type = $user_type[administrator]"));

  if ($user_data[5]=='t')
    $user_data[5] = "Enabled";
  else
    $user_data[5] = "Disabled";

  if ($user_data[6]=='t')
    $user_data[6] = "Enabled";
  else
    $user_data[6] = "Disabled";

  /* SEND MAIL TO THE CLIENT */
  $subject = "Photo Organizer Account Status Notificaiton";
  $message = "
      <html>
        <head>
          <title>Photo Organizer Account Status Notificaiton</title>
        </head>
        <body text=\"#555555\" bgcolor=\"#FFFFFF\" link=\"#0044AA\" vlink=\"#0044AA\" alink=\"#0044AA\">
          <font size=\"+1\">Dear $user_data[0],</font>
          <p>
          Your Photo Organizer account settings were changed to:
          <ul>
            <li> Account type: $user_data[4]";

  if ($user_data[3] == $user_type['user']) {
    $message = $message . "<li> Bulk upload: $user_data[5]";
    $message = $message . "<li> Shop: $user_data[6]";
  }

  if ($user_data[7] == 0) {
    $message = $message . "<li> Storage space quota: unlimited";
  }
  else {
    $user_data[7] = round($user_data[7]/1048576, 2);
    $message = $message . "<li> Storage space quota: $user_data[7] Mb";
  }

  if ($user_data[8] == 0) {
    $message = $message . "<li> Photo count quota: unlimited";
  }
  else {
    $message = $message . "<li> Photo count quota: $user_data[8] photos, including versions";
  }

  $message = $message . "</ul> Should you have any questions please contact your PO administrator.";
  $message = $message . "<p>
          This e-mail has been automatically generated by PO.
          <p>
          $admin_data[0] $admin_data[1], your PO administrator.
          <p>
        </body>
      </html>";
  $headers  = "MIME-Version: 1.0\r\n";
  $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
  $headers .= "From: $admin_data[2]\r\n";

  if (!mail($user_data[2], $subject, $message, $headers))
    return FALSE;

  return TRUE;
}


function send_po_order_notification($database, $user_id, $client_id) {
  global $user_type;
  global $client_status;
  global $site_url;

  $user_data = pg_query($database, "
     select users.first_name, users.last_name, email
       from users, contact_info
      where users.contact = contact_info.identifier
        and users.identifier = '$user_id'");

  $num_of_to_users = pg_num_rows($user_data);
  if ($num_of_to_users != 1)
    return FALSE;

  $client_data = pg_query($database, "
     select users.identifier, users.first_name, users.last_name, email,
       from users, contact_info
      where users.contact = contact_info.identifier
        and users.identifier = '$client_id'");

  $num_of_to_users = pg_num_rows($client_data);
  if ($num_of_to_users != 1)
    return FALSE;


  /* SEND MAIL TO THE USER */
  $subject = "Photo Organizer Shop Notificaiton";
  $message = "
      <html>
        <head>
          <title>Photo Organizer Shop Notificaiton</title>
        </head>
        <body text=\"#555555\" bgcolor=\"#FFFFFF\" link=\"#0044AA\" vlink=\"#0044AA\" alink=\"#0044AA\">
          <font size=\"+1\">Dear $user_data[0],</font>
          <p>

          <a href=\"$site_url/user.php?user=$client_data[0]\">$client_data[1] $client_data[2]</a> submitted a new order.<br>
          Click here to see your <a href=\"$site_url/my.datebook.php?selector=2/\">pending orders</a>.

          This e-mail has been automatically generated by PO.
          <p>
        </body>
      </html>";
  $headers  = "MIME-Version: 1.0\r\n";
  $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
  $headers .= "From: $client_data[3]\r\n";

  if (!mail($user_data[2], $subject, $message, $headers))
    return FALSE;

  /* SEND MAIL TO THE CLIENT */
  $message = "
      <html>
        <head>
          <title>Photo Organizer Shop Notificaiton</title>
        </head>
        <body text=\"#555555\" bgcolor=\"#FFFFFF\" link=\"#0044AA\" vlink=\"#0044AA\" alink=\"#0044AA\">
          <font size=\"+1\">Dear $client_data[1],</font>
          <p>

          This e-mail is to confirm your order that you submitted recently using Photo Organizer.<br/>
          Click here to see your <a href=\"$site_url/my.datebook.php?selector=2/\">pending orders</a>.

          This e-mail has been automatically generated by PO.
          <p>
        </body>
      </html>";
  $headers  = "MIME-Version: 1.0\r\n";
  $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
  $headers .= "From: $user_data[2]\r\n";

  if (!mail($client_data[3], $subject, $message, $headers))
    return FALSE;

  return TRUE;
}

?>
