<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "common.php";
include_once "iptc.php";
include_once "exif.php";

$current_rdf_tag = "not_implemented";
$rdf_image_data = array ("author"                 => "",
                         "title"                  => "",
                         "keyword"                => "",
                         "caption"                => "",
                         "copyright"              => "",
                         "web_statement"          => "",
                         "caption_writer"         => "",
                         "category"               => "",
                         "credit"                 => "",
                         "source"                 => "",
                         "headline"               => "",
                         "instructions"           => "",
                         "transmission_reference" => "",
                         "supplemental_category"  => "",
                         "date_of_exposure"       => "null",
                         "city"                   => "null",
                         "state"                  => "null",
                         "country"                => "null",
                         "camera_model"           => "null",
                         "camera_make"            => "null",
                         "lens"                   => "null",
                         "film"                   => "null",
                         "flash"                  => "null",
                         "focal_length"           => "null",
                         "aperture"               => "null",
                         "shutter"                => "null",
                         "camera_metering"        => "null",
                         "camera_program"         => "null",
                         "flash_mode"             => "null");

/* as defined in the XMP spec January 2004 */
$metering_mode_conversion = array (0 => "null",  /* Unknown */
                                   1 => "null",  /* Average */
                                   2 => 2,       /* Center */
                                   3 => 1,       /* Spot */
                                   4 => 5,       /* MultiSpot */
                                   5 => "null",  /* Pattern */
                                   6 => "null",  /* Partial */
                                 255 => "null"); /* Other */

/* as defined in the XMP spec January 2004 */
$exposure_program_conversion = array (0 => "null",  /* Unknown */
                                      1 => 4,       /* Manual */
                                      2 => 1,       /* Normal */
                                      3 => 2,       /* Aperture */
                                      4 => 3,       /* Shutter */
                                      5 => "null",  /* Creative */
                                      6 => "null",  /* Action */
                                      7 => "null",  /* Portrait */
                                      8 => "null"); /* Landscape */

function convert_rdf2sql_timestamp($date, $time) {
  $year   = substr($date,  0, 4);
  $month  = substr($date,  5, 2);
  $day    = substr($date,  8, 2);

  if ($date == "" || $year == 0 || $month == 0 || $day == 0) {
    $today = getdate();
    $year   = $today['year'];
    $month  = $today['mon'];
    $day    = $today['mday'];
  }

  $hour   = substr($time,  0, 2);
  $minute = substr($time,  3, 2);
  $second = substr($time,  6, 2);

  if ($date == "") {
    $hour   = "00";
    $minute = "00";
    $second = "00";
  }

  $sql_timestamp = $year.'-'.$month.'-'.$day.' '.$hour.':'.$minute.':'.$second;
  return $sql_timestamp;
}

function rdf_concat($string, $word) {
  if (($string == "") || ($string == "null"))
    $string = $word;
  else {
    /* FIX FOR BUGGY XML PARSER */
    if (ord($word[0]) > 127)
      $string .= $word;
    else
      $string .= " ".$word;
  }
  return $string;
}

function rdf_concat_keyword($string, $word) {
  if ($string == "")
    $string = $word;
  else {
    /* FIX FOR BUGGY XML PARSER */
    if (ord($word[0]) > 127)
      $string .= $word;
    else
      $string .= "; ".$word;
  }
  return $string;
}

function convert_into_float($string) {
  $num_first  = substr($string, 0, strpos($string, "/"));
  $num_second = substr($string, strpos($string, "/")+1);
  return $num_first/$num_second;
}

function convert_rdf_lens_serial_number($database, $user_id, $serial_number) {
  $lens = pg_fetch_row(pg_query($database, "
     select identifier from lens
      where serial_number=$serial_number
        and users=$user_id"));
  if ($lens)
    return $lens[0];

  return "null";
}

function photo_parse_rdf($database, $index, $user_id, $image_data) {
  global $rdf_image_data;
  global $metering_mode_conversion;
  global $exposure_program_conversion;

  $rdf_image_data["author"]                 = "";
  $rdf_image_data["title"]                  = "";
  $rdf_image_data["keyword"]                = "";
  $rdf_image_data["caption"]                = "";
  $rdf_image_data["copyright"]              = "";
  $rdf_image_data["web_statement"]          = "";
  $rdf_image_data["caption_writer"]         = "";
  $rdf_image_data["category"]               = "";
  $rdf_image_data["credit"]                 = "";
  $rdf_image_data["source"]                 = "";
  $rdf_image_data["headline"]               = "";
  $rdf_image_data["instructions"]           = "";
  $rdf_image_data["transmission_reference"] = "";
  $rdf_image_data["supplemental_category"]  = "";
  $rdf_image_data["date_of_exposure"]       = "null";
  $rdf_image_data["city"]                   = "null";
  $rdf_image_data["state"]                  = "null";
  $rdf_image_data["country"]                = "null";
  $rdf_image_data["camera_model"]           = "null";
  $rdf_image_data["camera_make"]            = "null";
  $rdf_image_data["lens"]                   = "null";
  $rdf_image_data["film"]                   = "null";
  $rdf_image_data["flash"]                  = "null";
  $rdf_image_data["focal_length"]           = "null";
  $rdf_image_data["aperture"]               = "null";
  $rdf_image_data["shutter"]                = "null";
  $rdf_image_data["camera_metering"]        = "null";
  $rdf_image_data["camera_program"]         = "null";
  $rdf_image_data["flash_mode"]             = "null";

  $fp = fopen($image_data['file'][$index]['name_tmp'], "r");
  $data = fread($fp, filesize($image_data['file'][$index]['name_tmp']));

  $rdf_data_start = strstr($data, "<?xpacket begin");
  if (!$rdf_data_start) {
    fclose($fp);
    return $image_data;
  }

  $rdf_data = substr($rdf_data_start, 0, strpos($rdf_data_start, "<?xpacket end"));

  print "<li>Extracting RDF data ... ";

  /* first parse the xml file  */
  fseek ($fp, 0 ,SEEK_SET);
  $xml_parser = xml_parser_create("ISO-8859-1");
  xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, TRUE);
  xml_set_element_handler($xml_parser, "RDF_StartElement", "RDF_EndElement");
  xml_set_character_data_handler($xml_parser, "RDF_CharacterData");

  if (!xml_parse($xml_parser, $rdf_data)) {
    print sprintf("<font color=\"red\">%s, XML error: %d %s in file data.xml at line %d</font>\n<p>\n",
                  xml_to_html($rdf_data),
                  xml_get_error_code($xml_parser),
                  xml_error_string(xml_get_error_code($xml_parser)),
                  xml_get_current_line_number($xml_parser));
  }

  xml_parser_free($xml_parser);

  fclose($fp);
  print "done</li>";

  if ($rdf_image_data['author'] != "")
    $image_data['author'] = $rdf_image_data['author'];

  if ($rdf_image_data['title'] != "")
    $image_data['title'] = $rdf_image_data['title'];

  if ($rdf_image_data['keyword'] != "")
    $image_data['keyword'] = $rdf_image_data['keyword'];

  if ($rdf_image_data['caption'] != "")
    $image_data['caption'] = $rdf_image_data['caption'];

  if ($rdf_image_data['copyright'] != "")
    $image_data['copyright'] = $rdf_image_data['copyright'];

  if ($rdf_image_data['web_statement'] != "")
    $image_data['web_statement'] = $rdf_image_data['web_statement'];

  if ($rdf_image_data['caption_writer'] != "")
    $image_data['caption_writer'] = $rdf_image_data['caption_writer'];

  if ($rdf_image_data['category'] != "")
    $image_data['category'] = $rdf_image_data['category'];

  if ($rdf_image_data['credit'] != "")
    $image_data['credit'] = $rdf_image_data['credit'];

  if ($rdf_image_data['source'] != "")
    $image_data['source'] = $rdf_image_data['source'];

  if ($rdf_image_data['headline'] != "")
    $image_data['headline'] = $rdf_image_data['headline'];

  if ($rdf_image_data['instructions'] != "")
    $image_data['instructions'] = $rdf_image_data['instructions'];

  if ($rdf_image_data['transmission_reference'] != "")
    $image_data['transmission_reference'] = $rdf_image_data['transmission_reference'];

  if ($rdf_image_data['supplemental_category'] != "")
    $image_data['supplemental_category'] = $rdf_image_data['supplemental_category'];

  if ($rdf_image_data['date_of_exposure'] != "null")
    $image_data['date_of_exposure'] = convert_rdf2sql_timestamp($rdf_image_data['date_of_exposure'], "00:00:00");

  if (($rdf_image_data['city'] != "null") ||
      ($rdf_image_data['state'] != "null") ||
      ($rdf_image_data['country'] != "null")) {
    $image_data['location'] = convert_iptc_location($database,
                                                    $user_id,
                                                    $rdf_image_data['city'],
                                                    $rdf_image_data['state'],
                                                    $rdf_image_data['country']);
  }
  else {
    $image_data['location'] = "null";
  }

  if (($rdf_image_data['camera_make'] != "null") ||
      ($rdf_image_data['camera_model'] != "null"))
    $image_data['camera'] = convert_exif_camera($database, $user_id, $rdf_image_data['camera_make'], $rdf_image_data['camera_model']);

  if ($rdf_image_data['lens'] != "null")
    $image_data['lens'] = convert_rdf_lens_serial_number($database, $user_id, $rdf_image_data['lens']);

  if ($rdf_image_data['film'] != "null")
    $image_data['film'] = convert_exif_iso_film($database, $user_id, $rdf_image_data['film']);

  if ($rdf_image_data['flash'] != "null")
    $image_data['flash'] = $rdf_image_data['flash'];

  if ($rdf_image_data['focal_length'] != "null")
    $image_data['focal_length'] = convert_exif_focal_length($database, convert_into_float($rdf_image_data['focal_length']));

  if ($rdf_image_data['shutter'] != "null")
    $image_data['shutter'] = convert_exif_shutter($database, convert_into_float($rdf_image_data['shutter']));

  if ($rdf_image_data['aperture'] != "null")
    $image_data['aperture'] = convert_exif_aperture($database, "f/".convert_into_float($rdf_image_data['aperture']));

  if ($rdf_image_data['camera_metering'] != "null")
    $image_data['camera_metering'] = $metering_mode_conversion[$rdf_image_data['camera_metering']];

  if ($rdf_image_data['camera_program'] != "null")
    $image_data['camera_program'] = $exposure_program_conversion[$rdf_image_data['camera_program']];

  if ($rdf_image_data['flash_mode'] != "null")
    $image_data['flash_mode'] = $rdf_image_data['flash_mode'];

  return $image_data;
}

function RDF_CharacterData($parser, $data) {
  global $current_rdf_tag;
  global $rdf_image_data;

  /* check for crappy spaces */
  $test = ereg_replace(" ", "", $data);
  $test = ereg_replace("\n", "", $test);
  $test = ereg_replace("\r", "", $test);

  if (!$test)
    return;

  switch ($current_rdf_tag) {
  case "date_of_creation":
    $rdf_image_data['date_of_exposure'] = convert_rdf2sql_timestamp($data, "");
    break;
  case "city":
    $rdf_image_data['city'] = rdf_concat($rdf_image_data['city'], $data);
    break;
  case "state":
    $rdf_image_data['state'] = rdf_concat($rdf_image_data['state'], $data);
    break;
  case "country":
    $rdf_image_data['country'] = rdf_concat($rdf_image_data['country'], $data);
    break;
  case "web_statement":
    $rdf_image_data['web_statement'] = rdf_concat($rdf_image_data['web_statement'], $data);
    break;
  case "title":
    $rdf_image_data['title'] = rdf_concat($rdf_image_data['title'], $data);
    break;
  case "caption":
    $rdf_image_data['caption'] = rdf_concat($rdf_image_data['caption'], $data);
    break;
  case "copyright":
    $rdf_image_data['copyright'] = rdf_concat($rdf_image_data['copyright'], $data);
    break;
  case "author":
    $rdf_image_data['author'] = rdf_concat($rdf_image_data['author'], $data);
    break;
  case "keyword":
    if (!$rdf_image_data['keyword'])
      $rdf_image_data['keyword'] = rdf_concat($rdf_image_data['keyword'], $data);
    else
      $rdf_image_data['keyword'] = rdf_concat_keyword($rdf_image_data['keyword'], $data);
    break;
  case "caption_writer":
    $rdf_image_data['caption_writer'] = rdf_concat($rdf_image_data['caption_writer'], $data);
    break;
  case "category":
    $rdf_image_data['category'] = substr($data, 0, 3);
    break;
  case "credit":
    $rdf_image_data['credit'] = rdf_concat($rdf_image_data['credit'], $data);
    break;
  case "source":
    $rdf_image_data['source'] = rdf_concat($rdf_image_data['source'], $data);
    break;
  case "headline":
    $rdf_image_data['headline'] = rdf_concat($rdf_image_data['headline'], $data);
    break;
  case "instructions":
    $rdf_image_data['instructions'] = rdf_concat($rdf_image_data['instructions'], $data);
    break;
  case "transmission_reference":
    $rdf_image_data['transmission_reference'] = rdf_concat($rdf_image_data['transmission_reference'], $data);
    break;
  case "supplemental_category":
    $rdf_image_data['supplemental_category'] = rdf_concat($rdf_image_data['supplemental_category'], $data);
    break;
  case "web_statement":
    $rdf_image_data['web_statement'] = rdf_concat($rdf_image_data['web_statement'], $data);
    break;
  case "film":
    $rdf_image_data['film'] = $data;
    break;
  case "camera_make":
    $rdf_image_data['camera_make'] = $data;
    break;
  case "camera_model":
    $rdf_image_data['camera_model'] = $data;
    break;
  case "camera_metering":
    $rdf_image_data['camera_metering'] = $data;
    break;
  case "camera_program":
    $rdf_image_data['camera_program'] = $data;
    break;
  case "shutter":
    $rdf_image_data['shutter'] = $data;
    break;
  case "aperture":
    $rdf_image_data['aperture'] = $data;
    break;
  case "focal_length":
    $rdf_image_data['focal_length'] = $data;
    break;
  case "lens_serial_number":
    $rdf_image_data['lens'] = $data;
    break;
  }
}

function RDF_StartElement($parser, $name, $attribs) {
  global $current_rdf_tag;

  /* set current tag */
  switch ($name) {
  case "TIFF:MAKE":
    $current_rdf_tag = "camera_make";
    break;
  case "TIFF:MODEL":
    $current_rdf_tag = "camera_model";
    break;
  case "EXIF:ISOSPEEDRATINGS":
    $current_rdf_tag = "film";
    break;
  case "EXIF:EXPOSUREPROGRAM":
    $current_rdf_tag = "camera_program";
    break;
  case "EXIF:METERINGMODE":
    $current_rdf_tag = "camera_metering";
    break;
  case "EXIF:EXPOSURETIME":
    $current_rdf_tag = "shutter";
    break;
  case "EXIF:FNUMBER":
    $current_rdf_tag = "aperture";
    break;
  case "EXIF:FOCALLENGTH":
    $current_rdf_tag = "focal_length";
    break;
  case "AUX:SERIALNUMBER":
    $current_rdf_tag = "lens_serial_number";
    break;
  case "PHOTOSHOP:DATECREATED":
    $current_rdf_tag = "date_of_creation";
    break;
  case "PHOTOSHOP:CITY":
    $current_rdf_tag = "city";
    break;
  case "PHOTOSHOP:STATE":
    $current_rdf_tag = "state";
    break;
  case "PHOTOSHOP:COUNTRY":
    $current_rdf_tag = "country";
    break;
  case "PHOTOSHOP:CAPTIONWRITER":
    $current_rdf_tag = "caption_writer";
    break;
  case "PHOTOSHOP:CATEGORY":
    $current_rdf_tag = "category";
    break;
  case "PHOTOSHOP:CREDIT":
    $current_rdf_tag = "credit";
    break;
  case "PHOTOSHOP:SOURCE":
    $current_rdf_tag = "source";
    break;
  case "PHOTOSHOP:HEADLINE":
    $current_rdf_tag = "headline";
    break;
  case "PHOTOSHOP:INSTRUCTIONS":
    $current_rdf_tag = "instructions";
    break;
  case "PHOTOSHOP:TRANSMISSIONREFERENCE":
    $current_rdf_tag = "transmission_reference";
    break;
  case "PHOTOSHOP:SUPPLEMENTALCATEGORIES":
    $current_rdf_tag = "supplemental_category";
    break;
  case "XAPRIGHTS:WEBSTATEMENT":
    $current_rdf_tag = "web_statement";
    break;
  case "DC:TITLE":
    $current_rdf_tag = "title";
    break;
  case "DC:DESCRIPTION":
    $current_rdf_tag = "caption";
    break;
  case "DC:RIGHTS":
    $current_rdf_tag = "copyright";
    break;
  case "DC:CREATOR":
    $current_rdf_tag = "author";
    break;
  case "DC:SUBJECT":
    $current_rdf_tag = "keyword";
    break;
  }
}

function RDF_EndElement($parser, $name) {
  global $current_rdf_tag;

  /* reset current tag */
  switch ($name) {
  case "TIFF:MAKE":
    $current_rdf_tag = "not_implemented";
    break;
  case "TIFF:MODEL":
    $current_rdf_tag = "not_implemented";
    break;
  case "EXIF:ISOSPEEDRATINGS":
    $current_rdf_tag = "not_implemented";
    break;
  case "EXIF:EXPOSUREPROGRAM":
    $current_rdf_tag = "not_implemented";
    break;
  case "EXIF:METERINGMODE":
    $current_rdf_tag = "not_implemented";
    break;
  case "EXIF:EXPOSURETIME":
    $current_rdf_tag = "not_implemented";
    break;
  case "EXIF:FNUMBER":
    $current_rdf_tag = "not_implemented";
    break;
  case "EXIF:FOCALLENGTH":
    $current_rdf_tag = "not_implemented";
    break;
  case "AUX:SERIALNUMBER":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:DATECREATED":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:CAPTIONWRITER":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:CATEGORY":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:SUPPLEMENTALCATEGORIES":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:CITY":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:STATE":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:COUNTRY":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:CREDIT":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:SOURCE":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:HEADLINE":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:INSTRUCTIONS":
    $current_rdf_tag = "not_implemented";
    break;
  case "PHOTOSHOP:TRANSMISSIONREFERENCE":
    $current_rdf_tag = "not_implemented";
    break;
  case "XAPRIGHTS:WEBSTATEMENT":
    $current_rdf_tag = "not_implemented";
    break;
  case "DC:TITLE":
    $current_rdf_tag = "not_implemented";
    break;
  case "DC:DESCRIPTION":
    $current_rdf_tag = "not_implemented";
    break;
  case "DC:RIGHTS":
    $current_rdf_tag = "not_implemented";
    break;
  case "DC:CREATOR":
    $current_rdf_tag = "not_implemented";
    break;
  case "DC:SUBJECT":
    $current_rdf_tag = "not_implemented";
    break;
  }
}


?>
