<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "common.php";
include_once "search.2.php";

$tools_data = array("bulkupdate"      => array("idx" => 1, "active_img" => "$theme/navigator.tl.bulkupdate.a.gif",          "img" => "$theme/navigator.tl.bulkupdate.gif",          link => "my.tools.php?selector=1", "alt" => " Bulk Update "),
                    "shop_item_maker" => array("idx" => 2, "active_img" => "$theme/navigator.tl.shop.item.generator.a.gif", "img" => "$theme/navigator.tl.shop.item.generator.gif", link => "my.tools.php?selector=2", "alt" => " Shop Item Generator "),
                    "generator"       => array("idx" => 3, "active_img" => "$theme/navigator.tl.xmlgen.a.gif",              "img" => "$theme/navigator.tl.xmlgen.gif",              link => "my.tools.php?selector=3", "alt" => " XML Template Generator "),
                    "converter"       => array("idx" => 4, "active_img" => "$theme/navigator.tl.xmlconv.a.gif",             "img" => "$theme/navigator.tl.xmlconv.gif",             link => "my.tools.php?selector=4", "alt" => " XML Converter "),
                    "content_indexer" => array("idx" => 5, "active_img" => "$theme/navigator.tl.content.indexer.a.gif",     "img" => "$theme/navigator.tl.content.indexer.gif",     link => "my.tools.php?selector=5", "alt" => " Content Indexer "));

function display_xml_template_generator($database, $my_user_id) {
  global $style;
  global $color;
  global $theme;

  $users_location  = pg_query($database, "select identifier, country, state, city, place from view_location order by country, state, city, place");
  $users_folder    = pg_query($database, "select identifier, caption, parent_folder  from folder where users=$my_user_id[0] and caption!='Trash' and caption!='Orphanage' order by date_of_creation desc");
  $users_camera    = pg_query($database, "select identifier, name, model, variation from view_camera where users=$my_user_id[0]");
  $users_lens      = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length from view_lens where users=$my_user_id[0]");
  $users_film      = pg_query($database, "select identifier, name, model, iso       from view_film where users=$my_user_id[0]");
  $users_flash     = pg_query($database, "select identifier, name, model, variation from view_flash where users=$my_user_id[0]");
  $users_scanner   = pg_query($database, "select identifier, name, model, variation from view_scanner where users=$my_user_id[0]");
  $users_filter    = pg_query($database, "select identifier, name, model, variation from view_filter where users=$my_user_id[0]");
  $users_support   = pg_query($database, "select identifier, name, model, variation from view_support where users=$my_user_id[0]");

  $aperture        = pg_query($database, "select identifier, value from aperture");
  $focal_length    = pg_query($database, "select identifier, value from focal_length");
  $shutter         = pg_query($database, "select identifier, value from shutter");
  $ev_comp         = pg_query($database, "select identifier, value from ev_comp");
  $camera_metering = pg_query($database, "select identifier, value from camera_metering");
  $camera_program  = pg_query($database, "select identifier, value from camera_program");
  $flash_mode      = pg_query($database, "select identifier, value from flash_mode");
  $scan_resolution = pg_query($database, "select identifier, value from scan_resolution");
  $scan_bitdepth   = pg_query($database, "select identifier, value from scan_bitdepth");
  $scan_multiscan  = pg_query($database, "select identifier, value from scan_multiscan");
  $iso_override    = pg_query($database, "select identifier, value from film_iso");

  print "<form method=\"post\" action=\"xml.generator.php\" enctype=\"multipart/form-data\">\n";

  print "&nbsp;<br />";

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"2\">Fill in the image details and default values</td>\n";
  print "</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Image file name</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"75%\">";
  print "<input type=\"text\" name=\"file_name\" value=\"$file_name\" title=\"Root of the file name - the part which is constant\">";

  print "<select name=\"file_number_digits\" title=\"Number of digits in the file name including 0. For 00234 this number is 5\">";
  for ($i=1; $i < 11; $i++) {
    print "<option value=$i>$i";
  }
  print "</select>";
  print " . <input type=\"text\" name=\"file_format\" value=\"$file_format\" size=\"5\" title=\"File format, ex: jpg, gif, ...\">";

  print"</td>\n</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Start number</td>\n<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"75%\">";
  print "<input type=\"text\" name=\"file_number_start\" value=\"$file_number_start\" size=\"10\" title=\"File start number - the number of the first photo\">";
  print "</td>\n</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Number of frames</td>\n<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"75%\">";
  print "<input type=\"text\" name=\"frame_number\" value=\"$frame_number\" size=\"10\" title=\"For how many photos you want to generate the XML file\">";
  print "</td>\n</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Folder</td>            <td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_folder_combo("folder", $users_folder, $current_folder, "");
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Title</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<input type=\"text\" name=\"title\" size=\"60\" title=\"The title of the Photo\"></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Author</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<input type=\"text\" name=\"author\" size=\"60\" title=\"Photographer's Name\"></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Keywords</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"hard\"  name=\"keyword\" rows=3 cols=\"60\"></textarea></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Caption</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"hard\"  name=\"caption\" rows=\"7\" cols=\"60\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Exposure date</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_date_input_form("exposure_timestamp", "");
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Location</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_combo("location", $users_location, 0, ", ", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Storage Location</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_storage_location_combo("storage_location_type", "");
  print "<input type=\"text\" name=\"storage_location_id\" size=\"10\" title=\"Storage location identifier - this will be incremented when the index wraps around\"> -
         <input type=\"text\" name=\"storage_index\" size=\"4\" title=\"Storage location index - this must be a number and will be incremented for each photo\"> :
         <input type=\"text\" name=\"storage_size\" size=\"4\" title=\"Storage location size - the storage index will wrap around when reaches this limit\">";
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Access</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_access_combo("access_rights", "t", "");
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">High Resolution Original</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >";
  display_hide_original_combo("hide_original", "t");
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Camera</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_combo("camera", $users_camera, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Camera Metering</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("camera_metering", $camera_metering, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Camera Program</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("camera_program", $camera_program, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Lens</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_lens_combo("lens", $users_lens, 0, 0, 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Focal Length</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("focal_length", $focal_length, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Filter</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("filter", $users_filter, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Film</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("film", $users_film, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Film ISO Override</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("iso_override", $iso_override, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Aperture</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("aperture", $aperture, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Shutter Speed</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("shutter", $shutter, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Exposure Compensation</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("exp_comp", $ev_comp, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Ev Difference</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("exp_diff", $ev_comp, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Flash</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("flash", $users_flash, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Flash Mode</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("flash_mode", $flash_mode, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Flash Compensation</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("flash_comp", $ev_comp, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Scanner</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("scanner", $users_scanner, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Colorspace</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_colorspace_combo("colorspace", 1);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Scan Parameters</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("scan_resolution", $scan_resolution, 0, "", 0);
  print "dpi &nbsp;\n";
  display_combo("scan_bitdepth", $scan_bitdepth, 0, "", 0);
  print "bits &nbsp;\n";
  display_combo("scan_multiscan", $scan_multiscan, 0, "", 0);
  print "passes &nbsp;\n";
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Support</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("support", $users_support, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"30%\" nowrap>Copyright Statement</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"70%\">";
  print "<textarea wrap=\"hard\"  name=\"copyright\" rows=\"7\" cols=\"60\">$my_preferences[0]</textarea>\n";
  print "</td></tr>\n";
  print "</table>\n";
  print "&nbsp;<br />";
  print "<input type=\"image\" src=\"$theme/button.submit.gif\" border=\"0\" value=\"submit\">";
  print "</form>\n";
}

function display_bulk_update($database, $my_user_id, $url, $rule_identifier) {
  global $style;
  global $color;
  global $theme;

  $users_location = pg_query($database, "select identifier, country, state, city, place from view_location order by country, state, city, place");
  $users_camera   = pg_query($database, "select identifier, name, model, variation from view_camera where users=$my_user_id[0]");
  $users_lens     = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length from view_lens where users=$my_user_id[0]");
  $users_film     = pg_query($database, "select identifier, name, model, iso from view_film where users=$my_user_id[0]");
  $users_flash    = pg_query($database, "select identifier, name, model, variation from view_flash where users=$my_user_id[0]");
  $users_scanner  = pg_query($database, "select identifier, name, model, variation from view_scanner where users=$my_user_id[0]");
  $users_filter   = pg_query($database, "select identifier, name, model, variation from view_filter where users=$my_user_id[0]");
  $users_support  = pg_query($database, "select identifier, name, model, variation from view_support where users=$my_user_id[0]");

  $aperture        = pg_query($database, "select identifier, value from aperture");
  $focal_length    = pg_query($database, "select identifier, value from focal_length");
  $shutter         = pg_query($database, "select identifier, value from shutter");
  $ev_comp         = pg_query($database, "select identifier, value from ev_comp");
  $camera_metering = pg_query($database, "select identifier, value from camera_metering");
  $camera_program  = pg_query($database, "select identifier, value from camera_program");
  $flash_mode      = pg_query($database, "select identifier, value from flash_mode");
  $scan_resolution = pg_query($database, "select identifier, value from scan_resolution");
  $scan_bitdepth   = pg_query($database, "select identifier, value from scan_bitdepth");
  $scan_multiscan  = pg_query($database, "select identifier, value from scan_multiscan");
  $iso_override    = pg_query($database, "select identifier, value from film_iso");

  $users_folder    = pg_query($database, "select identifier, caption, parent_folder  from folder where users=$my_user_id[0] and caption!='Trash' and caption!='Orphanage' order by date_of_creation desc");
  $users_rules     = pg_query($database, "select identifier, rule_name  from bulk_update_rule where users=$my_user_id[0]");

  if ($rule_identifier) {
    $rule_data = pg_fetch_row(pg_query($database, "
     select regenerate_thumbnail, regenerate_preview,
       title, author, keyword, headline, caption_writer, caption,
       category, supplemental_category, credit, copyright_statement,
       web_statement, instructions, source, transmission_reference,
       date_of_exposure, location, access_rights, hide_original,
       camera, camera_metering, camera_program, lens, focal_length,
       filter, film, iso_override, aperture, shutter, exposure_comp,
       ev_difference, flash, flash_mode, flash_comp, scanner,
       scan_resolution, scan_bitdepth, scan_multiscan, support, rule_name
     from bulk_update_rule
    where identifier = $rule_identifier"));
  } else {
    $rule_data[18] = "null";
  }

  print "<form method=\"post\" action=\"bulk.update.php\" enctype=\"multipart/form-data\">\n";

  print "&nbsp;<br />";

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"2\">Search Criteria</td>\n";
  print "</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Folder</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_folder_combo("select_folder", $users_folder, $current_folder, "all");
  print "</td></tr>\n";
  print "</table>\n";

  print "<p>&nbsp;<p>";

  print "<table align=\"center\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\">\n";

  print "Recall Action: <select onchange=\"location=this.options[this.selectedIndex].value;\">\n";
  print "<option value=\"$url\">None\n";
  for ($i=0; $i < pg_num_rows($users_rules); $i++) {
    $rule = pg_fetch_row($users_rules, $i);
    if ($rule[0] == $rule_identifier)
      print "<option value=\"$url&amp;rule=$rule[0]\" selected>$rule[1]\n";
    else
      print "<option value=\"$url&amp;rule=$rule[0]\">$rule[1]\n";
  }
  print "</select>\n";

  print "</td><td align=\"right\" bgcolor=\"$color[table_body]\">\n";
  print "Current Action: <input name=\"set_rule_name\" value=\"$rule_data[40]\" >";
  print "<input type=\"hidden\" name=\"rule\" value=\"$rule_identifier\">";
  print "</td><td width=\"10\" align=\"right\" bgcolor=\"$color[table_body]\" nowrap>\n";
  print "<input type=\"image\" src=\"$theme/button.save.changes.gif\" border=\"0\" name=\"operator\" value=\"save\">";
  print "</td><td width=\"10\" align=\"right\" bgcolor=\"$color[table_body]\" nowrap>\n";
  print "<input type=\"image\" src=\"$theme/button.delete.gif\" border=\"0\" name=\"operator\" value=\"delete\">";
  print "</td></tr>\n";
  print "</table>\n";

  print "<p>&nbsp;<p>";

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"2\">Action</td>\n";
  print "</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Regenerate thumbnail</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_yes_no_combo("set_generate_thumbnail", $rule_data[0]);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Regenerate preview</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_yes_no_combo("set_generate_preview", $rule_data[1]);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Title</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_title\" rows=\"2\">$rule_data[2]</textarea></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Author</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_author\" rows=\"2\">$rule_data[3]</textarea></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Keywords</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_keyword\" rows=\"3\">$rule_data[4]</textarea></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Headline</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_headline\" rows=\"2\">$rule_data[5]</textarea></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Caption Writer</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_caption_writer\" rows=\"2\">$rule_data[6]</textarea></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Caption</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_caption\" rows=\"7\">$rule_data[7]</textarea></td></tr>\n";
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Category</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<input type=\"text\" name=\"set_category\" size=\"3\" title=\"Category\" value=\"$rule_data[8]\"></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Supplemental Category</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_supplemental_category\" rows=\"7\">$rule_data[9]</textarea></td></tr>\n";
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Credit</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_credit\" rows=\"2\">$rule_data[10]</textarea></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\" nowrap=\"nowrap\">Copyright Statement</td> <td align=\"left\" bgcolor=\"$color[table_body]\" width=\"70%\">";
  print "<textarea wrap=\"hard\" name=\"set_copyright\" rows=\"7\">$rule_data[11]</textarea>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Web Statement</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_web_statement\" rows=\"2\">$rule_data[12]</textarea></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Instructions</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_instructions\" rows=\"2\">$rule_data[13]</textarea></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Source</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_source\" rows=\"2\">$rule_data[14]</textarea></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Transmission Refernce</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_transmission_reference\" rows=\"2\">$rule_data[15]</textarea></td></tr>\n";
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Date of Exposure</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >";
  display_date_input_form("set_date_of_exposure", $rule_data[16]);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Location</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_combo("set_location", $users_location, $rule_data[17], ", ", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Access</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_access_combo("set_access_rights", $rule_data[18], "null");
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">High Resolution Original</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >";
  display_hide_original_combo("set_hide_original", $rule_data[19]);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Camera</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_combo("set_camera", $users_camera, $rule_data[20], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Camera Metering</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_camera_metering", $camera_metering, $rule_data[21], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Camera Program</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_camera_program", $camera_program, $rule_data[22], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Lens</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_lens_combo("set_lens", $users_lens, $rule_data[23], 0, 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Focal Length</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_focal_length", $focal_length, $rule_data[24], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Filter</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_filter", $users_filter, $rule_data[25], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Film</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_film", $users_film, $rule_data[26], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Film ISO Override</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_iso_override", $iso_override, $rule_data[27], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Aperture</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_combo("set_aperture", $aperture, $rule_data[28], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Shutter Speed</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_shutter", $shutter, $rule_data[29], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Exposure Compensation</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_exp_comp", $ev_comp, $rule_data[30], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Ev Difference</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_exp_diff", $ev_comp, $rule_data[31], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Flash</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_flash", $users_flash, $rule_data[32], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Flash Mode</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_flash_mode", $flash_mode, $rule_data[33], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Flash Compensation</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_flash_comp", $ev_comp, $rule_data[34], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Colorspace</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_colorspace_combo("colorspace", -1);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Scanner</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_scanner", $users_scanner, $rule_data[35], "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Scan Parameters</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_scan_resolution", $scan_resolution, $rule_data[36], "", 0);
  print "dpi &nbsp;\n";
  display_combo("set_scan_bitdepth", $scan_bitdepth, $rule_data[37], "", 0);
  print "bits &nbsp;\n";
  display_combo("set_scan_multiscan", $scan_multiscan, $rule_data[38], "", 0);
  print "passes &nbsp;\n";
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Support</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_support", $users_support, $rule_data[39], "", 0);
  print "</td></tr>\n";

  print "</table>\n";

  print "&nbsp;<br/>";

  print "<input type=\"image\" src=\"$theme/button.submit.gif\"  name=\"operator\" value=\"submit\">";
  print "</form>\n";
}


function display_shop_item_generator($database, $my_user_id) {
  global $style;
  global $color;
  global $theme;

  print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/select.js\"></script>";

  $users_folder = pg_query($database, "select identifier, caption, parent_folder  from folder where users=$my_user_id[0] and caption!='Trash' and caption!='Orphanage' order by date_of_creation desc");
  $all_user_rules  = pg_query($database, "
     select identifier, shop_category, shop_item, currency, price, comment, date_of_creation, date_of_last_edit
       from view_shop_item_generator_rule
      where users=$my_user_id[0]");

  print "&nbsp;<br />";

  print "<form name=\"shop_item_generator\" method=\"post\" action=\"shop.item.generator.php\" enctype=\"multipart/form-data\">\n";
  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"2\">Search Criteria</td>\n";
  print "</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Folder</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_folder_combo("select_folder", $users_folder, $current_folder, "all");
  print "</td></tr>\n";
  print "</table>\n";

  print "&nbsp;<br>\n";

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"8\">Create Shop Items</td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"1%\">&nbsp;</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"15%\">Category</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"15%\">Item</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"10%\">Currency</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"10%\">Price</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"39%\">Remark</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"10%\" colspan=\"2\"><a href=\"shop.item.generator.add.php\">Add Rule</a></td>\n";
  print "</tr>\n";
  for ($f=0; $f < pg_num_rows($all_user_rules); $f++) {
    $rules = pg_fetch_row($all_user_rules, $f);
    print "<tr>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\"><input type=\"checkbox\" name=\"rule$rules[0]\" value=\"$rules[0]\" onClick=\"sig_uncheck_del();\"></td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">$rules[1]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">$rules[2]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">$rules[3]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">$rules[4]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">$rules[5]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" width=\"5%\"><a href=\"shop.item.generator.edit.php?rule=$rules[0]\">Edit</a></td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" width=\"5%\"><a href=\"shop.item.generator.del.php?rule=$rules[0]\">Delete</a></td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"><input type=\"checkbox\" name=\"delete_all\" value=\"yes\" onClick=\"sig_uncheck_create();\"></td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" colspan=\"7\">Remove all shop items in the specified folder.</td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "&nbsp;<br>\n";
  print "<input type=\"image\" src=\"$theme/button.submit.gif\" border=\"0\" name=\"operator\" value=\"submit\">\n";
  print "</form>\n";

  print "&nbsp;<br>\n";

}

function display_content_indexer($database, $my_user_id, $url, $session_id) {
  global $style;
  global $color;
  global $theme;

  $users_folder = pg_query($database, "select identifier, caption, parent_folder  from folder where users=$my_user_id[0] and caption!='Trash' and caption!='Orphanage' order by date_of_creation desc");

  print "&nbsp;<br />";

  print "<form method=\"post\" action=\"content.indexer.php\" enctype=\"multipart/form-data\">\n";
  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"2\">Search Criteria</td>\n";
  print "</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Folder</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_folder_combo("select_folder", $users_folder, $current_folder, "all");
  print "</td></tr>\n";
  print "</table>\n";

  print "&nbsp;<br>\n";

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_content_submit("type");
  print "</td></tr>";
  print "</table>\n";
  print "&nbsp;<br>\n";
  print "<input type=\"image\" src=\"$theme/button.submit.gif\" border=\"0\" name=\"operator\" value=\"submit\">\n";
  print "</form>\n";

  print "&nbsp;<br>\n";
}

?>
