<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/profile.php";
include_once "include/database.php";
include_once "$theme/theme.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

include_once "include/calendar.php";

function add_lens($database, $user_id,
                  $lens_type_id, $lens_manufacturer_id, $lens_model, $lens_variation,
                  $lens_min_aperture_id, $lens_max_aperture_id, $lens_min_focal_length_id, $lens_max_focal_length_id, $lens_serial_number,
                  $lens_purchase_timestamp,
                  $lens_purchased_new, $lens_access_rights) {

  $lens_date_of_purchase = check_date_validity($lens_purchase_timestamp);

  $lens_model = pg_escape_string($lens_model);
  $lens_variation = pg_escape_string($lens_variation);
  $lens_serial_number = pg_escape_string($lens_serial_number);

  if ($lens_type_id=='custom') {
    $new_lens_type_id = pg_fetch_row(pg_query($database, "select nextval('lens_type_id_sequence')"));
    $lens_type_id = $new_lens_type_id[0];
    $result = pg_query($database, "insert into lens_type (identifier, manufacturer, model, variation, min_focal_length, max_focal_length, min_aperture, max_aperture, last_modified_date, last_modifying_users)
                                   values ($lens_type_id, $lens_manufacturer_id, '$lens_model', '$lens_variation', '$lens_min_focal_length_id', '$lens_max_focal_length_id', '$lens_min_aperture_id', '$lens_max_aperture_id', now(), '$user_id')");
    if (!$result) {
      print "Failed to create new lens type";
      return;
    }
  }

  $result = pg_query($database, "insert into lens (identifier, type, users, serial_number, date_of_purchase, purchased_new, access_rights)
                                 values (nextval('lens_id_sequence'), '$lens_type_id', '$user_id', '$lens_serial_number', $lens_date_of_purchase, '$lens_purchased_new', '$lens_access_rights')");
  if (!$result) {
    print "Failed to create new lens";
  }
}

$database = po_dbconnect();
$my_user_id = pg_fetch_row(pg_query($database, "select identifier from users where session_id='$session_id'"));
if ($my_user_id[0] == "") {
  pg_close($database);
  header("location: login.php");
  exit();
}

add_lens($database, $my_user_id[0], $_REQUEST['lens_type_id'], $_REQUEST['lens_manufacturer_id'], $_REQUEST['lens_model'], $_REQUEST['lens_variation'],
         $_REQUEST['lens_min_aperture_id'], $_REQUEST['lens_max_aperture_id'], $_REQUEST['lens_min_focal_length_id'], $_REQUEST['lens_max_focal_length_id'], $_REQUEST['lens_serial_number'],
         $_REQUEST['lens_purchase_timestamp'], $_REQUEST['lens_purchased_new'], $_REQUEST['lens_access_rights']);

pg_close($database);
header("location: my.profile.php?selector=".$profile_data['lens']['idx']);
?>
