<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

//  Try to turn off caching
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

include_once "include/vars.php";
include_once "include/config.php";
include_once "$theme/theme.php";
include_once "include/import.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

include_once "include/common.php";
include_once "include/site.php";
include_once "include/database.php";

$database = po_dbconnect();
$my_user_id = pg_fetch_row(pg_query($database, "select identifier, type from users where session_id='$session_id'"));
if ($my_user_id[1] < $user_type['user']) {
  pg_close($database);
  header("location: login.php");
  exit();
}

$preferences = pg_fetch_row(pg_query($database, "
  select bulk_upload_enable
    from users, preferences
   where preferences.identifier=users.preferences
     and users.identifier=$my_user_id[0]"));

$im_options = get_im_options($database, $my_user_id[0]);
$my_im_composite_options = get_im_composite_options($database, $my_user_id[0]);
$dcraw_options = get_dcraw_options($database, $my_user_id[0]);

$user_name          = pg_fetch_row(pg_query($database, "select first_name, last_name, identifier from users where identifier=$my_user_id[0]"));
$default_folder_id  = $_REQUEST['folder'];
$default_folder     = pg_fetch_row(pg_query($database, "select caption from folder where identifier='$default_folder_id'"));

$date_of_exposure   = check_date_validity($_REQUEST['exposure_timestamp']);

$file_name          = $_FILES['file_name']['name'][0];
$file_size          = $_FILES['file_name']['size'][0];
$file_name_tmp      = $_FILES['file_name']['tmp_name'][0];
$original_file_type = strtolower(substr($file_name, strrpos($file_name, ".") + 1));

$current_tag = "not_implemented";
$character_data =  "";

function load_default_image_data_values() {
  global $image_data;
  global $default_folder_id;
  global $date_of_exposure;

  $image_data = array ("num_of_files"           => 0,
                       "file"                   => array(0 => array("name" => "", "name_tmp" => "", "type" => "", "remark" => "", "master" => "")),
                       "folder"                 => $default_folder_id,
                       "author"                 => pg_escape_string($_REQUEST['author']),
                       "title"                  => pg_escape_string($_REQUEST['title']),
                       "keyword"                => pg_escape_string($_REQUEST['keyword']),
                       "caption"                => pg_escape_string($_REQUEST['caption']),
                       "caption_writer"         => pg_escape_string($_REQUEST['caption_writer']),
                       "web_statement"          => pg_escape_string($_REQUEST['web_statement']),
                       "copyright"              => pg_escape_string($_REQUEST['copyright']),
                       "supplemental_category"  => pg_escape_string($_REQUEST['supplemental_category']),
                       "category"               => substr(pg_escape_string($_REQUEST['category']), 0, 3),
                       "credit"                 => pg_escape_string($_REQUEST['credit']),
                       "source"                 => pg_escape_string($_REQUEST['source']),
                       "headline"               => pg_escape_string($_REQUEST['headline']),
                       "instructions"           => pg_escape_string($_REQUEST['instructions']),
                       "transmission_reference" => pg_escape_string($_REQUEST['transmission_referece']),
                       "date_of_exposure"       => $date_of_exposure,
                       "location"               => $_REQUEST['location'],
                       "storage_location_type"  => $_REQUEST['storage_location_type'],
                       "storage_location_id"    => $_REQUEST['storage_location_id'],
                       "storage_index"          => $_REQUEST['storage_index'],
                       "access_rights"          => $_REQUEST['access_rights'],
                       "hide_original"          => $_REQUEST['hide_original'],
                       "camera"                 => $_REQUEST['camera'],
                       "lens"                   => $_REQUEST['lens'],
                       "filter"                 => $_REQUEST['filter'],
                       "film"                   => $_REQUEST['film'],
                       "flash"                  => $_REQUEST['flash'],
                       "scanner"                => $_REQUEST['scanner'],
                       "focal_length"           => $_REQUEST['focal_length'],
                       "aperture"               => $_REQUEST['aperture'],
                       "shutter"                => $_REQUEST['shutter'],
                       "exp_comp"               => $_REQUEST['exp_comp'],
                       "exp_diff"               => $_REQUEST['exp_diff'],
                       "camera_metering"        => $_REQUEST['camera_metering'],
                       "camera_program"         => $_REQUEST['camera_program'],
                       "flash_mode"             => $_REQUEST['flash_mode'],
                       "flash_comp"             => $_REQUEST['flash_comp'],
                       "scan_resolution"        => $_REQUEST['scan_resolution'],
                       "scan_bitdepth"          => $_REQUEST['scan_bitdepth'],
                       "scan_multiscan"         => $_REQUEST['scan_multiscan'],
                       "iso_override"           => $_REQUEST['iso_override'],
                       "support"                => $_REQUEST['support'],
                       "orientation"            => 0,
                       "decode_exif"            => $_REQUEST['decode_exif'],
                       "decode_iptc"            => $_REQUEST['decode_iptc'],
                       "decode_rdf"             => $_REQUEST['decode_rdf'],
                       "colorspace"             => $_REQUEST['colorspace'],
                       "exif"                   => "",
                       "iptc"                   => "");
}

function XML_StartElement($parser, $name, $attribs) {
  global $image_data;
  global $current_folder;
  global $temporary_directory;
  global $database;
  global $current_tag;

  switch ($name) {
  case "BULKUPLOAD":
    break;
  case "FOLDER":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $current_folder = $value;
        }
      }
    }
    break;
  case "PHOTO":
    load_default_image_data_values();
    $image_data['folder'] = $current_folder;
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "TITLE":
          $image_data['title'] = $value;
          break;
        }
      }
    }
    break;

  case "AUTHOR":
    $current_tag = "author";
    break;
  case "KEYWORD":
    $current_tag = "keyword";
    break;
  case "CAPTION":
    $current_tag = "caption";
    break;
  case "COPYRIGHT":
    $current_tag = "copyright";
    break;
  case "CAPTION_WRITER":
    $current_tag = "caption_writer";
    break;
  case "CATEGORY":
    $current_tag = "category";
    break;
  case "CREDIT":
    $current_tag = "credit";
    break;
  case "SOURCE":
    $current_tag = "source";
    break;
  case "HEADLINE":
    $current_tag = "headline";
    break;
  case "INSTRUCTIONS":
    $current_tag = "instructions";
    break;
  case "TRANSMISSION_REFERENCE":
    $current_tag = "transmission_reference";
    break;
  case "SUPPLEMENTAL_CATEGORY":
    $current_tag = "supplemental_category";
    break;
  case "WEB_STATEMENT":
    $current_tag = "web_statement";
    break;

  case "FILE":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "NAME":
          $image_data['file'][$image_data['num_of_files']]['name']     = $temporary_directory . "/" . $value;
          $image_data['file'][$image_data['num_of_files']]['name_tmp'] = $temporary_directory . "/" . $value;
          $image_data['file'][$image_data['num_of_files']]['type']     = strtolower(substr($value, strrpos($value, ".") + 1));
          break;
        case "REMARK":
          $image_data['file'][$image_data['num_of_files']]['remark']   = $value;
          break;
        case "MASTER":
          $image_data['file'][$image_data['num_of_files']]['master']   = ($value == "yes") ? "t" : "f";
          break;
        }
      }
    }
    $image_data['num_of_files']++;;
    break;
  case "EXPDATE":
    $today = getdate(time());
    $year  = $today["year"];
    $month = $today["month"];
    $day   = $today["day"];
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "YEAR":
          $year = $value;
          break;
        case "MONTH":
          $month = $value;
          break;
        case "DAY":
          $day = $value;
        }
      }
      $image_data['date_of_exposure'] = sprintf("%04d-%02d-%02d", $year, $month, $day);
    }
    break;
  case "LOCATION":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['location'] = $value;
        }
      }
    }
    break;
  case "STORAGE":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "TYPE":
          $image_data['storage_location_type'] = $value;
          break;
        case "ID":
          $image_data['storage_location_id'] = $value;
          break;
        case "IDX":
          $image_data['storage_index'] = $value;
        }
      }
    }
    break;
  case "ACCESS":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "TYPE":
          $image_data['access_rights'] = $value;
          break;
        case "ORIGINAL":
          switch ($value) {
          case "owner":
            $image_data['hide_original'] = 't';
            break;
          case "all":
            $image_data['hide_original'] = 'f';
            break;
          }
        }
      }
    }
    break;
  case "CAMERA":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['camera'] = $value;
          break;
        case "METER":
          switch ($value) {
          case "spot":
            $image_data['camera_metering'] = 1;
            break;
          case "center":
            $image_data['camera_metering'] = 2;
            break;
          case "matrix":
            $image_data['camera_metering'] = 3;
            break;
          case "colormatrix":
            $image_data['camera_metering'] = 4;
            break;
          case "zone":
            $image_data['camera_metering'] = 5;
          }
          break;
        case "PROG":
          switch ($value) {
          case "auto":
            $image_data['camera_program'] = 1;
            break;
          case "aperture":
            $image_data['camera_program'] = 2;
            break;
          case "shutter":
            $image_data['camera_program'] = 3;
            break;
          case "manual":
            $image_data['camera_program'] = 4;
          }
          break;
        case "SPEED":
          $shutter_id = pg_fetch_row(pg_query($database, "select identifier from shutter where value='$value'"));
          if ($shutter_id)
            $image_data['shutter'] = $shutter_id[0];
          break;
        case "COMP":
          $exp_comp_id = pg_fetch_row(pg_query($database, "select identifier from ev_comp where value='$value'"));
          if ($exp_comp_id)
            $image_data['exp_comp'] = $exp_comp_id[0];
          break;
        case "EVDIFF":
          $ev_diff_id = pg_fetch_row(pg_query($database, "select identifier from ev_comp where value='$value'"));
          if ($ev_diff_id)
            $image_data['exp_diff'] = $ev_diff_id[0];
        }
      }
    }
    break;
  case "LENS":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['lens'] = $value;
          break;
        case "FOCAL":
          $focal_id = pg_fetch_row(pg_query($database, "select identifier from focal_length where value='$value'"));
          if ($focal_id)
            $image_data['focal_length'] = $focal_id[0];
          break;
        case "APERT":
          $aperture_id = pg_fetch_row(pg_query($database, "select identifier from aperture where value='$value'"));
          if ($aperture_id)
            $image_data['aperture'] = $aperture_id[0];
        }
      }
    }
    break;
  case "FILTER":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['filter'] = $value;
        }
      }
    }
    break;
  case "FILM":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['film'] = $value;
          break;
        case "OVERRIDE":
          $film_iso_override = pg_fetch_row(pg_query($database, "select identifier from film_iso where value='$value'"));
          if ($film_iso_override)
            $image_data['iso_override'] = $film_iso_override[0];
          break;
        }
      }
    }
    break;
  case "FLASH":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['flash'] = $value;
          break;
        case "MODE":
          switch ($value) {
          case "normal":
            $image_data['flash_mode'] = 1;
            break;
          case "slow":
            $image_data['flash_mode'] = 2;
            break;
          case "rear":
            $image_data['flash_mode'] = 3;
          }
          break;
        case "COMP":
          $flash_comp_id = pg_fetch_row(pg_query($database, "select identifier from ev_comp where value='$value'"));
          if ($flash_comp_id)
            $image_data['flash_comp'] = $flash_comp_id[0];
        }
      }
    }
    break;
  case "SCANNER":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['scanner'] = $value;
          break;
        case "DPI":
          $dpi_id = pg_fetch_row(pg_query($database, "select identifier from scan_resolution where value='$value'"));
          if ($dpi_id)
            $image_data['scan_resolution'] = $dpi_id[0];
          break;
        case "BITDEPTH":
          $bitdepth_id = pg_fetch_row(pg_query($database, "select identifier from scan_bitdepth where value='$value'"));
          if ($bitdepth_id)
            $image_data['scan_bitdepth'] = $bitdepth_id[0];
          break;
        case "PASS":
          $multiscan_id = pg_fetch_row(pg_query($database, "select identifier from scan_multiscan where value='$value'"));
          if ($multiscan_id)
            $image_data['scan_multiscan'] = $multiscan_id[0];
        }
      }
    }
    break;
  case "SUPPORT":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['support'] = $value;
        }
      }
    }
  }
}

function XML_CharacterData($parser, $data) {
  global $character_data;
  $character_data = $data;
}

function XML_EndElement($parser, $name) {
  global $image_data;
  global $database;
  global $thumb_max_size;
  global $image_max_size;
  global $default_folder_id;
  global $im_options;
  global $my_im_composite_options;
  global $dcraw_options;
  global $my_user_id;
  global $character_data;
  global $current_tag;

  switch ($name) {
  case "PHOTO":
    /* check for the master version and if found upload it */
    $photo_master_id = false;
    for ($index = 0; $index < $image_data['num_of_files']; $index++) {
      if ($image_data['file'][$index]['master'] == 't')
        $photo_master_id = photo_import($database, $index, $im_options, $my_im_composite_options, $dcraw_options, $my_user_id, $default_folder_id, $image_data);
    }

    for ($index = 0; $index < $image_data['num_of_files']; $index++) {
      /* upload all other photos as versions */
      if ($image_data['file'][$index]['master'] != 't') {
        /* if no master was found in the first round, default the first photo as the master */
        if (!$photo_master_id)
          $photo_master_id = photo_import($database, $index, $im_options, $my_im_composite_options, $dcraw_options, $my_user_id, $default_folder_id, $image_data);
        else {
          $image_data['file'][$index]['master'] = 'f';
          photo_version_import($database, $index, $im_options, $my_im_composite_options, $dcraw_options, $my_user_id, $photo_master_id, $image_data);
        }
      }
    }
    load_default_image_data_values();
    break;
  case "AUTHOR":
    $image_data['author'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "KEYWORD":
    $image_data['keyword'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "CAPTION":
    $image_data['caption'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "COPYRIGHT":
    $image_data['copyright'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "CAPTION_WRITER":
    $image_data['caption_writer'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "CATEGORY":
    $image_data['category'] = substr($character_data, 0, 3);
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "CREDIT":
    $image_data['credit'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "SOURCE":
    $image_data['source'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "HEADLINE":
    $image_data['headline'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "INSTRUCTIONS":
    $image_data['instructions'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "TRANSMISSION_REFERENCE":
    $image_data['transmission_reference'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "SUPPLEMENTAL_CATEGORY":
    $image_data['supplemental_category'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "WEB_STATEMENT":
    $image_data['web_statement'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
  }
}

function XML_EndTestElement($parser, $name) {
  switch ($name) {
  case "PHOTO":
    print ".";
    break;
  }
}

load_default_image_data_values();
$image_data['file'][0]['name']     = $file_name;
$image_data['file'][0]['name_tmp'] = $file_name_tmp;
$image_data['file'][0]['type']     = $original_file_type;
$image_data['file'][0]['remark']   = "";
$image_data['file'][0]['master']   = "t";
$image_data['num_of_files'] = 1;

site_header($page_width, "Photo Organizer : Import Photos");
site_navigator(5, $my_user_id[1]);
$path_to_folder = get_path_to_folder($database, $default_folder_id);
site_navigator_staus("<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$user_name[2]\">My folders and albums</a>$path_to_folder : <a href=folder.php?folder=$default_folder_id>$default_folder[0]</a> : Import photos", "");

print "&nbsp;<br>";
print "<table align=\"left\" border=\"0\" width=\"100%\"><tr><td align=\"left\" >" ;

switch ($original_file_type) {
 default:
   photo_import($database, 0, $im_options, $my_im_composite_options, $dcraw_options, $my_user_id, $default_folder_id, $image_data);
   print "</p><p>Import finished.</p>";
   print "</td></tr></table>" ;

   print "&nbsp;<br>";

   site_footer($database);
   pg_close($database);
   exit();
 case "gz":
 case "tgz":
 case "bz2":
 case "bzip2":
 case "tar":
 case "zip":
   /* check if bulk upload is enabled for this user */
   if ($preferences[0] == 'f') {
     print "Bulk upload is disabled for this account.<br>Contact you Photo Organizer administrator to enable this feature.<p>";
     break;
   }
   /* in case the file type is zip, uncompress it and process the bulk upload */
   $next_index = pg_fetch_row(pg_query($database, "select nextval('bulk_upload_id_sequence')"));
   $temporary_directory = $tmp_volume_path."/po.import.".$next_index[0];
   print "Creating temporary directory <b>$temporary_directory</b> ... ";
   $old_mask = umask(0000);
   if (!mkdir($temporary_directory)) {
     print "<font color=\"red\">failed</font> [mkdir $temporary_directory]<br>";
   }
   else {
     print "done.<br>";
   }

   print "Move uploaded file into temporary directory ... ";
   if (!move_uploaded_file($file_name_tmp, $temporary_directory . "/" . $file_name)) {
     print "<font color=\"red\">failed</font> [mv $file_name_tmp $temporary_directory/$file_name] <br>";
   }
   else {
     print "done.<br>";
   }

   print "Uncompressing $file_name ... ";

   switch ($original_file_type) {
   case "gz":
   case "tgz":
     system("$sys_tar -x -z -C " .
            escapeshellarg($temporary_directory) ." -f" .
            escapeshellarg($temporary_directory ."/" . $file_name), $retval);
     if ($retval) {
       print "<font color=\"red\">failed</font> [tar -x -z -C $temporary_directory -f $temporary_directory/$file_name]<br>";
     }
     else {
       print "done.<br>";
     }
     break;
   case "bzip2":
   case "bz2":
     system("$sys_tar -x -j -C ".
            escapeshellarg($temporary_directory) ." -f".
            escapeshellarg($temporary_directory ."/". $file_name), $retval);
     if ($retval) {
       print "<font color=\"red\">failed</font> [tar -x -j -C $temporary_directory -f $temporary_directory/$file_name]<br>";
     }
     else {
       print "done.<br>";
     }
     break;
   case "tar":
     system("$sys_tar -x -C ".
            escapeshellarg($temporary_directory) ." -f".
            escapeshellarg($temporary_directory ."/". $file_name), $retval);
     if ($retval) {
       print "<font color=\"red\">failed</font> [tar -x -C $temporary_directory -f $temporary_directory/$file_name]<br>";
     }
     else {
       print "done.<br>";
     }
     break;
   case "zip":
     system("$sys_unzip -q ".
            escapeshellarg($temporary_directory. "/". $file_name) ." -d".
            escapeshellarg($temporary_directory), $retval);
     if ($retval) {
       print "<font color=\"red\">failed</font> [unzip $temporary_directory/$file_name -d temporary_directory]<br>";
     }
     else {
       print "done.<br>";
     }
     break;
   }

   print "Looking for the <b>data.xml</b> file ... ";
   if (is_file($temporary_directory . "/data.xml")) {
     $fp = fopen($temporary_directory . "/data.xml", "r");
     print "found.\n<br>\n";
     print "Validating XML file:  ";

     /* first parse the xml file  */
     fseek ($fp, 0 ,SEEK_SET);
     $xml_parser = xml_parser_create();
     xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, TRUE);
     xml_set_element_handler($xml_parser, "XML_StartElement", "XML_EndTestElement");

     $data = fread($fp, filesize($temporary_directory . "/data.xml"));
     if (!xml_parse($xml_parser, $data)) {
       print sprintf("<font color=\"red\">%s, XML error: %d %s in file data.xml at line %d</font>\n<p>\n",
                     $data,
                     xml_get_error_code($xml_parser),
                     xml_error_string(xml_get_error_code($xml_parser)),
                     xml_get_current_line_number($xml_parser));
       xml_parser_free($xml_parser);
       fclose($fp);
       exit;
     }

     xml_parser_free($xml_parser);

     print " well formed.<br>";
     print "&nbsp;<br>";

     /* now do a real upload as described in the xml file */
     fseek ($fp, 0 ,SEEK_SET);

     $xml_parser = xml_parser_create();
     xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, TRUE);
     xml_set_element_handler($xml_parser, "XML_StartElement", "XML_EndElement");
     xml_set_character_data_handler($xml_parser, "XML_CharacterData");

     while ($data = fread($fp, 4096)) {
       if (!xml_parse($xml_parser, $data, feof($fp))) {
         print sprintf("<font color=\"red\">XML error: %d %s in file data.xml at line %d</font>\n<p>\n",
                       xml_get_error_code($xml_parser),
                       xml_error_string(xml_get_error_code($xml_parser)),
                       xml_get_current_line_number($xml_parser));
         xml_parser_free($xml_parser);
         fclose($fp);
         exit;
       }
     }

     xml_parser_free($xml_parser);

     if (!fclose($fp)) {
       print "Failed to close XML document";
     }
   }
   else {
     print "not found.\n<br>\n";
     print "&nbsp;<br>";
   }

   /* upload the rest of the files which where not described in the xml file */
   umask(0077);
   if ($handle = opendir($temporary_directory)) {
     /* create an array to store the master versions of each photo */
     $master_versions = array();
     while (false !== ($file_name = readdir($handle))) {
       if ($file_name == "." || $file_name == "..")
         continue;

       $file_type = substr($file_name, strrpos($file_name, ".") + 1);
       if ($file_type == "xml"   || $file_type == "gz"  ||
           $file_type == "tgz"   || $file_type == "zip" ||
           $file_type == "bz2"   || $file_type == "tar" ||
           $file_type == "bzip2") {
         unlink($temporary_directory . "/" . $file_name);
         continue;
       }

       load_default_image_data_values();
       $image_data['file'][0]['name']     = $temporary_directory . "/" . $file_name;
       $image_data['file'][0]['name_tmp'] = $temporary_directory . "/" . $file_name;
       $image_data['file'][0]['type']     = $file_type;
       $image_data['file'][0]['remark']   = "";
       $image_data['file'][0]['master']   = "t";
       $image_data['num_of_files'] = 1;

       $file_name_root = substr($file_name, 0, strrpos($file_name, "."));
       if (!$file_name_root) {
         /* if no dot was found, upload it as a master version */
         $file_name_root = $file_name;
         $master_versions[$file_name_root] = photo_import($database, 0, $im_options, $my_im_composite_options, $dcraw_options, $my_user_id, $default_folder_id, $image_data);
       }
       else {
         if (!$master_versions[$file_name_root]) {
           $master_versions[$file_name_root] = photo_import($database, 0, $im_options, $my_im_composite_options, $dcraw_options, $my_user_id, $default_folder_id, $image_data);
         }
         else {
           photo_version_import($database, 0, $im_options, $my_user_id, $my_im_composite_options, $dcraw_options, $master_versions[$file_name_root], $image_data);
         }
       }
     }
     closedir($handle);
   }

   print "Removing temporary directory <b>$temporary_directory</b> ... ";
   if (!rmdir($temporary_directory)) {
     print "<font color=\"red\">failed</font> [rmdir $temporary_directory]<br>";
   }
   else {
     print "done.<br>";
     print "&nbsp;<br>";
   }
   umask($old_mask);
   print "&nbsp;<br>";
   break;
}

print "&nbsp;<br>";
print "Upload finished.<br>";
print "&nbsp;<br>";
print "</td></tr></table>" ;

print "&nbsp;<br>";

site_footer($database);
pg_close($database);

?>
