<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/import.php";
include_once "include/database.php";
include_once "$theme/theme.php";

$num_of_keywords = $_REQUEST['num_of_keywords'];
$num_of_selected_keywords = 0;
$keyword_list = "";
for ($counter = 0; $counter < $num_of_keywords; $counter++) {
  $keyword = $_REQUEST[keyword.$counter];
  if ($keyword) {
    $keyword_list = $keyword_list."$keyword%20";
    $num_of_selected_keywords++;
  }
}
if ($num_of_selected_keywords > 0) {
  header("location: search.text.advanced.php?keyword=$keyword_list");
  exit();
}

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

$database = po_dbconnect();
$my_user_id = pg_fetch_row(pg_query($database, "select identifier from users where session_id='$session_id'"));
if ($my_user_id[0] == "") {
  pg_close($database);
  header("location: login.php");
  exit();
}

include_once "include/common.php";
include_once "include/site.php";

$photo_id           = $_REQUEST['photo_id'];
$version            = $_REQUEST['version'];
$destination_basket = $_REQUEST['basket'];
$destination_folder = $_REQUEST['destination_folder'];
$destination_album  = $_REQUEST['destination_album'];
$set_as_watermark   = $_REQUEST['set_as_watermark'];
$goto_folder        = $_REQUEST['goto_folder'];
$print_type         = $_REQUEST['print_type'];
$detail_info        = $_REQUEST['detail_info'];
$transform          = $_REQUEST['transform'];


if ($goto_folder != "") {
  header("location: folder.php?folder=$goto_folder");
  exit();
}

if ($my_user_id[1] == $user_type['administrator']) {
  $user_id = $_REQUEST['user'];
}
if (!$user_id) {
  $user_id = $my_user_id[0];
}

if (($transform == "") &&
    ($destination_folder == "") &&
    ($destination_album == "") &&
    ($print_type == "") &&
    ($set_as_watermark == "") &&
    ($destination_basket == "")) {
  header("location: photo.php?photo=$photo_id&detail_info=$detail_info");
  exit();
}

if ($print_type != "") {
  pg_query($database, "delete from photo_spooler where users=$my_user_id[0]");
  pg_query($database, "insert into photo_spooler (identifier, users, photo)
                       values (nextval('photo_spooler_id_sequence'), $my_user_id[0], $photo_id)");
  pg_close($database);
  header("location: print.php?source_photo=$photo_id&print_type=$print_type");
  exit();
}

if ($destination_folder != "") {
  pg_query($database, "update photo set folder='$destination_folder' where identifier='$photo_id'");
}
elseif ($destination_album != "") {
  pg_query($database, "insert into album_content (identifier, photo, album)
                       values (nextval('album_content_id_sequence'), $photo_id, $destination_album)");
}
elseif ($destination_basket != "") {
  $all_photos_for_sale = pg_query($database, "
   select identifier,
          (select identifier
             from shop_order
            where shop_order.item=photo_item.identifier
              and shop_order.client=$my_user_id[0]
              and transaction is null) as already_selected
     from photo_item
    where photo=$photo_id");

  for ($counter = 0; $counter < pg_num_rows($all_photos_for_sale); $counter++) {
    $photo_for_sale = pg_fetch_row($all_photos_for_sale, $counter);
    if ($photo_for_sale[1]) {
      /* if already in the basket, update or remove */
      if ($_REQUEST[cb.$photo_for_sale[0]] != 'on') {
        pg_query($database, "
          delete from shop_order
           where item=$photo_for_sale[0]
             and client=$my_user_id[0]");
      }
    }
    else {
      /* if not in the basket insert if selected */
      if ($_REQUEST[cb.$photo_for_sale[0]] == 'on') {
        pg_query($database, "
          insert into shop_order (identifier, item, client, transaction, pieces, date_of_creation, date_of_last_edit, download_expiry_date)
          values (nextval('shop_order_id_sequence'), $photo_for_sale[0], $my_user_id[0], null, 1, now(), now(), now())");
      }
    }
  }
}
elseif ($set_as_watermark != "") {
  pg_query($database, "update imagemagick_composite_options
                          set photo_version = (select identifier from photo_version where photo=$photo_id)
                        where identifier = (select imagemagick_composite_options from users where identifier = $my_user_id[0])");
}
elseif ($transform != "") {

  $version_selector = $version ? "photo_version.identifier=$version" : "photo_version.master='t'";

  $photo_paths = pg_fetch_row(pg_query($database, "
    select small_image_path, medium_image_path, large_image_path, colorspace, orientation, photo_version.identifier, camera
      from photo, photo_version, photo_tech
     where photo.identifier = photo_version.photo
       and photo.identifier = photo_tech.photo
       and $version_selector
       and photo.identifier = '$photo_id'"));

  $thumb = $image_repository_path ."/". $photo_paths[0];
  $preview = $image_repository_path ."/". $photo_paths[1];
  $original = $image_repository_path ."/". $photo_paths[2];
  $colorspace = $photo_paths[3];
  $orientation = $photo_paths[4];
  $version_id = $photo_paths[5];
  $camera_type = $photo_paths[6];

  $orientation = map_transform($orientation, $transform);

  pg_query($database, "update photo_version set orientation = $orientation where identifier = $version_id");

  $im_composite_options = get_im_composite_options($database, $my_user_id[0]);
  $im_options = get_im_options($database, $my_user_id[0]);
  $dcraw_options = get_dcraw_options($database, $my_user_id[0]);

  $orientation = orientation_to_xform($database, $orientation);

  $original_file_type   = strtolower(substr($original, strrpos($original, ".") + 1));
  $multi_page_parameter = $mime_type[$original_file_type]['page'];
  $decoder              = $mime_type[$original_file_type]['decoder'];
  $postprocessor        = $mime_type[$original_file_type]['postprocessor'];

  $temporary_ppm_file = import_raw_decode($original, $dcraw_options, $decoder, $postprocessor);
  if ($temporary_ppm_file) {
    $original = $temporary_ppm_file;
  }

  import_generate_preview($original, $preview, FALSE, $im_options, $im_composite_options, $multi_page_parameter, $orientation,	$colorspace);
  import_generate_thumbnail($original, $thumb, FALSE, $im_options, $multi_page_parameter, $orientation, $colorspace);
}


pg_close($database);
header("location: photo.php?photo=$photo_id&detail_info=$detail_info&ver=$version");
?>
