<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/orderby.php";
include_once "include/search.php";
include_once "include/database.php";
include_once "$theme/theme.php";

function display_general_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id) {
  global $theme;
  global $search_interface;
  global $site_url;

  print "&nbsp;<br>\n";

  display_navigator_box_top($search_interface['text_general']['idx'], $search_interface, "100%");

  print "&nbsp;<br>";
  print "<table align=\"center\" border=\"0\">";
  print "<tr><td  align=\"center\">";
  print "<input type=\"text\" name=\"search_string\" value=\"$search_string\" size=\"50\">";
  print "</td><td >";

  print "<select onchange=\"location = this.options[this.selectedIndex].value;\">\n";
  for ($i = 0; $i < 3; $i++)
    if ($search_type == $i)
      print "<option value=\"search.text.general.php?search_type=$i\" selected>$search_type_string[$i]";
    else
      print "<option value=\"search.text.general.php?search_type=$i\">$search_type_string[$i]";
  print "</select>";
  print "<input type=\"hidden\" name=\"search_type\" value=\"$search_type\">";

  print "</td>";

  if ($search_type_string[$search_type] != "Users") {
    print "<td >";
    print generate_html_users_combo("current_user", $database, $current_user_id, "");
    print "</td>";
    $colspan = 3;
  }
  else {
    $colspan = 2;
  }

  print "</tr>";
  print "<tr><td align=\"center\" colspan=\"$colspan\">";
  print "<input type=\"image\" src=\"$theme/button.search.gif\" border=\"0\" value=\"Search\">\n";
  print "</td></tr>";
  print "</table>";

  print "<p align=\"right\"><a href=\"javascript:window.sidebar.addPanel('Photo Organizer', '$site_url/search.sidebar.php', '' );\">Add sidebar panel</a></p>";

  display_navigator_box_bottom("100%");

  print "&nbsp;<br>\n";
}

$search_type_string = array ("Photos", "Folders", "Users");

$num_of_rows_l  = $default_num_of_rows_in_list_view;
$num_of_rows    = $default_num_of_rows_in_slide_view;
$num_of_columns = $default_num_of_columns;
$popup_enable   = $default_popup_enable;
$popup_delay    = $default_popup_delay;

$search_type    = $_REQUEST['search_type'];
$search_string  = $_REQUEST['search_string'];
$search_string  = validate_search_string($search_string);
$current_user_id = $_REQUEST['current_user'];
if (!$current_user_id || ($current_user_id=="all")) {
  $current_user_id = "null";
  $sql_photo_users_string = " ";
  $sql_folder_users_string = " ";
}
else {
  $sql_photo_users_string = " and photo.users = $current_user_id ";
  $sql_folder_users_string = " and folder.users = $current_user_id ";
}

$order_by = $_REQUEST['order_by'];
if (!$order_by) {
  $order_by = 1;
}

$sql_query_order_by_string = $order_by_string[$order_by][0];
$ignored_keywords = "";

$session_id    = $_COOKIE[$po_cookie];
$database      = po_dbconnect();
$my_user_id    = pg_fetch_row(pg_query($database, "select identifier, type from users where session_id='$session_id'"));
$offset        = $_REQUEST['offset'];
if (!$offset) {
  $offset = 0;
}

if ($my_user_id[0]!="") {
  $preferences = pg_fetch_row(pg_query($database, "
     select num_of_rows, num_of_columns, popup_enable, popup_delay, search_enable_stemming
       from users, preferences
      where preferences.identifier=users.preferences
        and users.identifier=$my_user_id[0]"));
  $num_of_rows     = $preferences[0];
  $num_of_columns  = $preferences[1];
  $popup_enable    = $preferences[2];
  $popup_delay     = $preferences[3];
  $enable_stemming = $preferences[4];
}

site_header($page_width, "Photo Organizer : Search");
site_navigator(2, $my_user_id[1]);

$keywords = extract_keywords($search_string, $enable_stemming);

if (!$keywords) {
  site_navigator_staus("Type search string below:", "");
  print "<form action=\"search.text.general.php\" method=\"post\">";
  display_general_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id);
  if ($ignored_keywords != "") {
    print "&nbsp;<br>\n";
    print "<div align=\"center\" >\n";
    print "The following keywords were ignored: $ignored_keywords<br>";
    print "Use quotation marks to force the search engine to include these keywords.";
    print "</div></p>\n";
  }
  print "&nbsp;<br>\n";
  print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/wz_tooltip.js\"></script>";
  site_footer($database);
  pg_close($database);
  exit();
}

switch ($search_type) {
 default:
 case 0: /* photo search */
   $status_string="Displaying photos";

   $sql_search_identifier = build_sql_search_string($keywords, "photo.identifier");
   $sql_search_title      = build_sql_search_string($keywords, "photo.title");
   $sql_search_author     = build_sql_search_string($keywords, "photo.author");
   $sql_search_keyword    = build_sql_search_string($keywords, "photo.keyword");
   $sql_search_caption    = build_sql_search_string($keywords, "photo.caption");
   $sql_search_place      = build_sql_search_string($keywords, "view_location.place");
   $sql_search_city       = build_sql_search_string($keywords, "view_location.city");
   $sql_search_state      = build_sql_search_string($keywords, "view_location.state");
   $sql_search_country    = build_sql_search_string($keywords, "view_location.country");

   $sql_search_combined_1 = "(".$sql_search_identifier." OR ".$sql_search_title ." OR ".$sql_search_author." OR ".$sql_search_keyword." OR ".$sql_search_caption.")";
   $sql_search_combined_2 = "(".$sql_search_identifier." OR ".$sql_search_title." OR ".$sql_search_author." OR ".$sql_search_keyword." OR ".$sql_search_caption." OR ".$sql_search_place." OR ".$sql_search_city." OR ".$sql_search_state." OR ".$sql_search_country.")";

   if ($my_user_id[0] == "") {
     $sql_query_access_rights_string = "photo.access_rights = $access[public]";
   }
   else {
     $sql_query_access_rights_string = "((photo.access_rights = $access[public]) or
                                         (photo.access_rights = $access[protected] and $my_user_id[0] in (select client from client where users=photo.users)) or
                                         (photo.users = $my_user_id[0]))";
   }


   /* query number of matches in a separate query, because the union might result duplicates */
   $num_of_matches_a = pg_fetch_row(pg_query($database, "
          select count(identifier) from photo where identifier in
         ((select photo.identifier
            from photo, folder, photo_dupe, photo_version, users
           where photo.folder = folder.identifier
             and photo.users = users.identifier
                 $sql_photo_users_string
             and photo.identifier = photo_version.photo
             and photo.identifier = photo_dupe.photo
             and photo_version.master='t'
             and photo_dupe.key = 1
             and ($sql_search_combined_1)
             and $sql_query_access_rights_string)
           union
         (select photo.identifier
            from photo, folder, photo_dupe, photo_version, users, view_location
           where photo.folder = folder.identifier
             and photo.users = users.identifier
                 $sql_photo_users_string
             and photo.identifier = photo_version.photo
             and photo.identifier = photo_dupe.photo
             and photo_version.master='t'
             and photo_dupe.key = 1
             and photo.location = view_location.identifier
             and ($sql_search_combined_2)
             and $sql_query_access_rights_string))"));

  $num_of_matches = $num_of_matches_a[0];

   $offset = $_REQUEST['offset'];
   if (!$offset) {
     $offset = 0;
   }

   $limit = $num_of_rows * $num_of_columns;
   if ($limit > $num_of_matches) {
     $limit = $num_of_matches;
   }

   $search_result = pg_query($database, "
         (select photo.identifier, photo_version.small_image_path, photo.caption, date_of_exposure, photo_dupe.date_of_creation,
                 (select value from access_type where access_type.identifier=photo.access_rights) as access_rights,
                 11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
                 views,
                 (0) as for_sale,
                 photo.title, photo.author, photo.keyword,
                 photo_version.original_image_name, photo.users
            from photo, folder, photo_dupe, photo_version, users
           where photo.folder = folder.identifier
             and photo.users = users.identifier
                 $sql_photo_users_string
             and photo.identifier = photo_version.photo
             and photo.identifier = photo_dupe.photo
             and photo_version.master='t'
             and photo_dupe.key = 1
             and ($sql_search_combined_1)
             and $sql_query_access_rights_string)
           union
         (select photo.identifier, photo_version.small_image_path, photo.caption, date_of_exposure, photo_dupe.date_of_creation,
                 (select value from access_type where access_type.identifier=photo.access_rights) as access_rights,
                 11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
                 views,
                 (0) as for_sale,
                 photo.title, photo.author, photo.keyword,
                 photo_version.original_image_name, photo.users
            from photo, folder, photo_dupe, photo_version, users, view_location
           where photo.folder = folder.identifier
             and photo.users = users.identifier
                 $sql_photo_users_string
             and photo.identifier = photo_version.photo
             and photo.identifier = photo_dupe.photo
             and photo_version.master='t'
             and photo_dupe.key = 1
             and photo.location = view_location.identifier
             and ($sql_search_combined_2)
             and $sql_query_access_rights_string)
           order by $sql_query_order_by_string
          offset $offset
           limit $limit");
   break;
 case 1: /* folder search */
   $status_string = "Displaying folders";
   $sql_search_string = build_sql_search_string($keywords, "folder.caption");
   if ($my_user_id[0] == "") {
     $sql_query_access_rights_string = "access_rights = $access[public]";
   }
   else {
     $sql_query_access_rights_string = "(users = $my_user_id[0] or access_rights = $access[public])";
   }

   $search_result = pg_query($database,
        "select caption, folder.identifier, date_of_creation,
                first_name, last_name, users.identifier
           from folder, users
          where $sql_search_string
                $sql_folder_users_string
            and $sql_query_access_rights_string
            and users.identifier = folder.users
          order by caption");
   $num_of_matches = pg_num_rows($search_result);
   break;
 case 2: /* user search */
   $status_string = "Displaying users";

   $sql_search_string = "(".
     build_sql_search_string($keywords, "last_name")." OR ".
     build_sql_search_string($keywords, "first_name")." OR ".
     build_sql_search_string($keywords, "username").")";

   $search_result = pg_query($database,
         "select identifier, first_name, last_name, member_since
            from users
           where ($sql_search_string)
             and type > $user_type[client]
           order by last_name, first_name");
   $num_of_matches = pg_num_rows($search_result);
}

if ($num_of_matches == 0) {
  $itemized_search_string = build_itemized_search_string($search_string, "search_string", "search_type=".$search_type."&");
  site_navigator_staus("No matches found for $itemized_search_string", "");

  print "<form action=\"search.text.general.php\" method=\"post\">";
  display_general_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id);
  print "</form>";
  if ($ignored_keywords != "") {
    print "&nbsp;<br>\n";
    print "<center>\n";
    print "The following keywords were ignored: $ignored_keywords<br>";
    print "Use quotation marks to force the search engine to include these keywords.";
    print "</center></p>\n";
  }
  print "&nbsp;<br>\n";
  print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/wz_tooltip.js\"></script>";
  site_footer($database);
  pg_close($database);
  exit();
}

$itemized_search_string = build_itemized_search_string($search_string, "search_string", "search_type=".$search_type."&");
site_navigator_staus("Searched database for $itemized_search_string",  $status_string. " " . display_photo_index_status($offset, $limit, $num_of_matches));
print "<form action=\"search.text.general.php\" method=\"post\">";
display_general_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id);
print "</form>";
if ($ignored_keywords != "") {
  print "&nbsp;<br>\n";
  print "<center>\n";
  print "The following keywords were ignored: $ignored_keywords<br>";
  print "Use quotation marks to force the search engine to include these keywords.";
  print "</center>\n";
}
print "&nbsp;<br>\n";

switch ($search_type) {
 default:
 case 0: /* photo search */
   $arguments = "&search_type=$search_type";

   if ($order_by) {
     $arguments = $arguments . "&order_by=$order_by";
   }

   $search_string_exp = str_replace(" ", "+", $search_string);

   print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/select.js\"></script>";
   print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/util.js\"></script>";

   print "<form  name=\"photoList\" method=\"post\" action=\"folder.content.php\">";
   print "<input type=\"hidden\" name=\"user\" value=\"$user_id\">";
   print "<input type=\"hidden\" name=\"return\" value=\"search.text.general.php?search_string=$search_string$arguments\">";
   print "<input type=\"hidden\" name=\"view\" value=\"$view\">";

   if (($offset + $limit) > $num_of_matches) {
     $items = $num_of_matches - $offset;
   }
   else {
     $items = $limit;
   }

   display_photo_navigator("search_general", $arguments, $my_user_id[0], $search_string_exp, $offset, $limit, $num_of_matches);
   $checkboxes = display_photo_slides("search_general", $my_user_id[0], $my_user_id[1], $folder_id, $search_result, $items, $num_of_columns, $popup_enable, $popup_delay, $shop_enable, true, $order_by);
   display_photo_navigator("search_general", $arguments, $my_user_id[0], $search_string_exp, $offset, $limit, $num_of_matches);

   print "&nbsp;<br>\n";
   $itemized_search_string = build_itemized_search_string($search_string, "search_string", "search_type=".$search_type."&");
   site_navigator_staus("Searched database for $itemized_search_string",  $status_string ." " . display_photo_index_status($offset, $limit, $num_of_matches));

   print "<table align=\"left\" valign=\"middle\" cellpadding=\"0\" border=\"0\">";
   print "<tr><td align=\"left\" valign=\"middle\">";

   print "<table align=\"left\" valign=\"middle\" cellpadding=\"0\" border=\"0\">";
   print "<tr>";
   print "<td align=\"left\" valign=\"middle\">";
   display_order_by_combo_with_button($order_by);
   print "</td>";
   if ($checkboxes > 0 && $my_user_id[0] != "") {
     print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
     display_printto();
     print "</td>";
   }
   print "</tr>";
   print "</table>";

   print "</td></tr><tr><td align=\"left\" valign=\"middle\">";

   print "<table align=\"left\" valign=\"middle\" cellpadding=\"0\" border=\"0\">";
   print "<tr>";

   if ($checkboxes > 0 && $my_user_id[0] != "") {
     $folder_all = pg_query($database, "select identifier, caption, parent_folder from folder where users=$my_user_id[0] order by date_of_creation desc");
     print "<td align=\"left\" valign=\"middle\">";
     display_moveto_folder($folder_all, $folder_id, "goto");
     print "</td>";

     print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
     display_moveto_folder($folder_all, $folder_id, "moveto");
     print "</td>";

     $album_all = pg_query($database, "select identifier, caption from album where users=$my_user_id[0] and type='u' order by date_of_creation desc");
     if (pg_num_rows($album_all) > 0) {
       print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
       display_linkto_album($album_all, $album_id);
       print "</td>";
     }

     print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
     print "<a class=\"nodecor\" href=\"javascript:setChecked('photocb'); changeImage('selectButton', '$theme/button.deselect.all.gif', '$theme/button.select.all.gif')\"><img name=\"selectButton\" src=\"$theme/button.select.all.gif\" border=\"0\"></a>\n";
     print "</td>";
   }
   print "</tr>";
   print "</table>";

   print "</td></tr>";
   print "</table>";

   print "</form>";
   break;
 case 1: /* folder search */
   display_folder_with_users($database, $my_user_id[0], $search_result);
   print "&nbsp;<br>\n";
   $itemized_search_string = build_itemized_search_string($search_string, "search_string", "search_type=".$search_type."&");
   site_navigator_staus("Searched database for $itemized_search_string",  $status_string ." " . display_photo_index_status($offset, 0, $num_of_matches));
   break;
 case 2: /* user search */
   display_users($database, $search_result, "");
   print "&nbsp;<br>\n";
   $itemized_search_string = build_itemized_search_string($search_string, "search_string", "search_type=".$search_type."&");
   site_navigator_staus("Searched database for $itemized_search_string",  $status_string ." " . display_photo_index_status($offset, 0, $num_of_matches));
}

print "&nbsp;<br>\n";
print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/wz_tooltip.js\"></script>";
site_footer($database);
pg_close($database);
?>
